#ifndef H66305_66301_H
#define H66305_66301_H

#include <vector>
#include <fstream>
#include <string>

using namespace std;

class CRaport;
class CStatystyka;
class CWartosc;

class CDane
{
protected:
  char* NazwaPliku;
  int TypPliku;
  CRaport* Raport;
  CStatystyka* Statystyka;
  vector <CWartosc*> Wartosc;
public:
  void CzytajDane();
  void ZapiszDane(fstream* a);
  void SetNazwaPliku(string nazwa);
  vector <CWartosc*>* GetWektorDanych();
  CDane() {};
  ~CDane() {};
};

class CRaport
{
protected:
  string NazwaPliku;
  bool ZapisacDane;
  int Precyzja;
  CDane* Dane;
  CStatystyka* Statystyka;
public:
  void ZapiszRaport();
  void SetZapisacDane(bool x);
  void SetPrecyzja(int x);
  CRaport();
  ~CRaport();
};

class CStatystyka
{
protected:
  CDane* Dane;
  CRaport* Raport;
public:
  virtual void ZapiszStatystyka(fstream*);
  virtual void Oblicz();
  CStatystyka();
  ~CStatystyka();
};

class CSredniaArytmetyczna : public CStatystyka
{
protected:
  double WartoscStatystyki;
public:
  void ZapiszStatystyka(fstream*);
  int Oblicz();
  CSredniaArytmetyczna();
  ~CSredniaArytmetyczna();
};

class CSredniaLiczbaWartosci : public CStatystyka
{
protected:
  double WartoscStatystyki;
public:
  void ZapiszStatystyka(fstream*) {};
  void Oblicz() {};
  CSredniaLiczbaWartosci();
  ~CSredniaLiczbaWartosci();
};

class CWartosc
{
protected:
  CDane* Dane;
public:
  virtual void ZapiszWartosc(fstream*);
  virtual void CzytajWartosc(fstream*);
  virtual int KonwertujDoInt();
  virtual string KonwertujDoString();
  CWartosc();
  ~CWartosc();
};

class CWartoscNominalna : public CWartosc
{
protected:
  string Wartosc;
public:
  void ZapiszWartosc(fstream*);
  void CzytajWartosc(fstream*);
  int KonwertujDoInt();
  string KonwertujDoString();
  CWartoscNominalna();
  ~CWartoscNominalna();
};

class CWartoscLiczbowa : public CWartosc
{
protected:
  int Wartosc;
public:
  void ZapiszWartosc(fstream*);
  void CzytajWartosc(fstream*);
  int KonwertujDoInt();
  string KonwertujDoString();
  CWartoscLiczbowa();
  ~CWartoscLiczbowa();
};


#endif
