/*
  obsluga sieci wymiany plikow wg. protokolu grupy I4, z srody 8:00
  Jacek Pospychaa (66301)
 */

#ifndef H66301_COMMON_H
#define H66301_COMMON_H

#include <stdlib.h>

/* DEBUG to maska okrelajca, ktre komunikaty maj by wywietlane.
 */
#define GENERAL_DBG 1
#define MEM_DBG     2
#define MESSAGE_DBG 4
#define X_DBG       8
#define SESSION_DBG 16
#define SEM_DBG     32
#define DATADIR_DBG 64
#define TRACE_DBG   128

#define DEBUG 0
//#define DEBUG GENERAL_DBG|MEM_DBG|MESSAGE_DBG|X_DBG|SESSION_DBG|SEM_DBG|TRACE_DBG
//#define DEBUG GENERAL_DBG|MESSAGE_DBG|SESSION_DBG

#define DEBUGMSG(a,b) if (((int)(DEBUG) & (int)(a)) > 0) { printf b; };

#define ASSERT(a,b) if (!(a)) { printf("ASSERT at %d in %s: " b "\n", __LINE__ , __FILE__); CALL_EXIT; }

#ifndef TRUE
#  define FALSE 0
#  define TRUE (! FALSE)
#endif

/* flaga dla receive_message() jeli podano oczekiwan komend:
    - jeli flaga jest ustawiona - wiadomoci o innej komendzie 
      bd odsyane spowrotem do listy
    - jeli flaga nie jest ustawiona - wiadomoci bd usuwane */
#define KEEP_UNWANTED 1

#ifdef H66301_SERVER
#define CALL_EXIT safe_exit(SIGTERM)
#else
#define CALL_EXIT exit(0)
#endif

/* struktura wiadomoci, nie podzielonej na fragmenty
 */
typedef struct complete_msg {
  long clientid;
  int command;
  char* argument1;
  char* argument2;
  char* messagebody;
} complete_msg;

size_t strnlen(char* s, int n);
void *xmalloc(size_t size);
void xfree(void* ptr);
int ereg(char* pattern, char* s);

int create_queue(int qid);
void close_queue(int qid);

ssize_t xmsgrcv(int msqid, void* msgp, size_t msgsz, long msgtyp, int msgflg);
int xmsgsnd(int msqid, void* msgp, size_t msgsz, int msgflg);

int command_has_args(int command);
int command_has_body(int command);

int send_message(int msgid, complete_msg* message);
int receive_message(int msgid, long clientid, int command, complete_msg* message, int flag);
void free_message(complete_msg* message);

void answer_error(complete_msg* msg, char* error_msg);
void answer_success(complete_msg* msg);

#endif
