unit prog_ean;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IntervalArithmetic, ComCtrls, Math, Menus,
  Grids;

type
  Tdatatype = (Tinteger, Textended, Tinterval);

  {
    Klasa Tvalue definiujaca elementy arytmetyki w jakiej
    beda wykonywane obliczenia.
    Zawiera 4 podstawowe operacje arytmetyczne (+, -, *, /),
    oraz podstawowe operatory relacji (=, >, <, >=, <=)
  }
  Tvalue = class (TObject)
  private
    datatype :Tdatatype;
    e :extended;
    v :interval;
    i :integer;
  public
    property getv :interval read v;
    function setval(v :integer) : Tvalue; overload;
    function setval(v :extended) : Tvalue; overload;
    function setval(v :interval) : Tvalue; overload;
    function setval(v :Tvalue) : Tvalue; overload;
    // podstawowe operacje matematyczne - zmieniaja wartosc klasy
    function vmul(operand :Tvalue) : Tvalue;
    function vdiv(operand :Tvalue) : Tvalue;
    function vadd(operand :Tvalue) : Tvalue;
    function vsub(operand :Tvalue) : Tvalue;
    // nie zmieniaja wartosci klasy, zwracaja wynik
    function omul(operand :Tvalue) : Tvalue;
    function odiv(operand :Tvalue) : Tvalue;
    function oadd(operand :Tvalue) : Tvalue;
    function osub(operand :Tvalue) : Tvalue;
    // podstawowe relacje
    function equal(operand :Tvalue) :boolean;
    function greaterthan(operand :Tvalue) :boolean;
    function lowerthan(operand :Tvalue) :boolean;
    function greaterequal(operand :Tvalue) :boolean;
    function lowerequal(operand :Tvalue) :boolean;
    // konstruktory
    constructor Create(vtype: Tdatatype); overload;
    constructor Create(e :extended); overload;
    constructor Create(v :interval); overload;
    constructor Create(i :integer); overload;
    // konstruktor uniwersalny, rozpoznajacy typ danych w stringu
    constructor Create(data :string); overload;
    // konstruktor kopiujcy
    constructor Create(operand :Tvalue); overload;
    // wpisujacy losowa wartosc
    function Random(wykmin :integer; wykmax :integer) :Tvalue;
    // wypisywanie
    function toString :string;
    function Read(s :string) :Tvalue;
  end;

  {
    Klasa Tmatrix do reprezentacji macierzy. Definiuje
    podstawowe operacje na nich.
  }
  Tmatrix = class (TObject)
  private
    function matrixwidth :integer;
    function matrixheight :integer;
    function matrixvtype :Tdatatype;
  public
    items :array of array of Tvalue;
    property width : integer read matrixwidth;
    property height : integer read matrixheight;
    property vtype :Tdatatype read matrixvtype;
    function mmul(operand :Tmatrix) : Tmatrix; overload;
    function mmul(operand :Tvalue) : Tmatrix; overload;
    function madd(operand :Tmatrix) : Tmatrix;
    function msub(operand :Tmatrix) : Tmatrix;
    function zamien_wiersze(rowA, rowB :integer) :Tmatrix;
    function wyznacznik_metszkolna :Tvalue;
    function odwroc(var det :Tvalue) :Tmatrix;
    constructor Create(orig :Tmatrix); overload;
    constructor Create(height :integer; width :integer; vtype :Tdatatype); overload;
    constructor Create(nazwapliku :string); overload;
    constructor CreateRandom(height :integer; width :integer; vtype :Tdatatype;
                             wykmin :integer; wykmax :integer); overload;
    function I :Tmatrix;
    procedure dopliku(nazwa :string);
    procedure doplikuderive(nazwa :string);
  end;

type
  TForm1 = class(TForm)
    plik: TOpenDialog;
    MainMenu1: TMainMenu;
    Macierz1: TMenuItem;
    Nowa1: TMenuItem;
    Zpliku1: TMenuItem;
    Losowa1: TMenuItem;
    Operacje1: TMenuItem;
    Jednostkowa1: TMenuItem;
    Diagonalna1: TMenuItem;
    Gornotrojkatna1: TMenuItem;
    Dolnotrojkatna1: TMenuItem;
    Oblicz1: TMenuItem;
    Pomoc1: TMenuItem;
    Oprogramie1: TMenuItem;
    Przezrozkladnaczynnikitrojkatne1: TMenuItem;
    m: TStringGrid;
    N1: TMenuItem;
    Zakoncz1: TMenuItem;
    Odswiez1: TMenuItem;
    N2: TMenuItem;
    Zapisz1: TMenuItem;
    ZapiszdoDerive1: TMenuItem;
    N3: TMenuItem;
    Nowa2: TMenuItem;
    zapisz_plik: TSaveDialog;
    Widok1: TMenuItem;
    MacierzA1: TMenuItem;
    MacierzL11: TMenuItem;
    MacierzU1: TMenuItem;
    MacierzA11: TMenuItem;
    AA11: TMenuItem;
    est1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Jednostkowa1Click(Sender: TObject);
    procedure Diagonalna1Click(Sender: TObject);
    procedure Gornotrojkatna1Click(Sender: TObject);
    procedure Dolnotrojkatna1Click(Sender: TObject);
    procedure Zpliku1Click(Sender: TObject);
    procedure Nowa1Click(Sender: TObject);
    procedure Losowa1Click(Sender: TObject);
    procedure Zakoncz1Click(Sender: TObject);
    procedure Oprogramie1Click(Sender: TObject);
    procedure Metodaszkolna1Click(Sender: TObject);
    procedure mSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure Odswiez1Click(Sender: TObject);
    procedure Zapisz1Click(Sender: TObject);
    procedure ZapiszdoDerive1Click(Sender: TObject);
    procedure Przezrozkladnaczynnikitrojkatne1Click(Sender: TObject);
    procedure MacierzA1Click(Sender: TObject);
    procedure MacierzA11Click(Sender: TObject);
    procedure MacierzL11Click(Sender: TObject);
    procedure MacierzU1Click(Sender: TObject);
    procedure AA11Click(Sender: TObject);
    procedure est1Click(Sender: TObject);
  private
    current :Tmatrix;
  public
    procedure pokazmacierz; overload;
    procedure pokazmacierz(a :Tmatrix); overload;
    { Public declarations }
  end;

  procedure zero_counters;

var
  Form1: TForm1;
  A, Ainv, L, U, AAinv :Tmatrix;
  errmulcounter :integer;
  mulcounter :integer;
  sumcounter :integer;

implementation

  uses Unit2, Unit3, Unit4, Unit5, Unit6;

{$R *.dfm}

procedure zero_counters;
begin
errmulcounter := 0;
mulcounter := 0;
sumcounter := 0;
end;

// * * * * * * * * * * * * * *
// * * * * * * * * * * * * * *
// Tvalue
// * * * * * * * * * * * * * *
// * * * * * * * * * * * * * *
function Tvalue.setval(v :integer) : Tvalue;
var s :string;
begin
case datatype of
  Tinteger: self.i := v;
  Tinterval:
   begin
    s := inttostr(v);
    self.v := int_read(s);
    end;
  Textended: self.e := v;
end;
Result := self;
end;

function Tvalue.setval(v :extended) : Tvalue;
var s :string;
begin
case datatype of
  Tinteger: self.i := round(v);
  Tinterval:
    begin
    s := floattostr(v);
    self.v := int_read(s);
    end;
  Textended: self.e := v;
end;
Result := self;
end;

function Tvalue.setval(v :interval) : Tvalue;
begin
case datatype of
  Tinteger: self.i := round(v.a);
  Tinterval: self.v := v;
  Textended: self.e := v.a;
end;
Result := self;
end;

function Tvalue.setval(v :Tvalue) : Tvalue;
begin
self.datatype := v.datatype;
self.i := v.i; self.v := v.v; self.e := v.e;
Result := self;
end;

function Tvalue.vmul(operand :Tvalue) : Tvalue;
var newe :Extended;
begin
Inc(mulcounter);
case datatype of
  Tinteger: i := i * operand.i;
  Textended:
    begin
    newe := e * operand.e;
    if e=0 then
      newe := e
    else
      begin
      if newe/e - operand.e <> 0 then
        Inc(errmulcounter);
      e := newe
      end;
    end;
  Tinterval: v := imul(v, operand.v);
end;
Result := self;
end;

function Tvalue.vdiv(operand :Tvalue) : Tvalue;
begin
case datatype of
  Tinteger: i := i div operand.i;
  Textended: e := e / operand.e;
  Tinterval: v := idiv(v, operand.v);
end;
Result := self;
end;

function Tvalue.vadd(operand :Tvalue) : Tvalue;
begin
Inc(sumcounter);
case datatype of
  Tinteger: i := i + operand.i;
  Textended: e := e + operand.e;
  Tinterval: v := iadd(v, operand.v);
end;
Result := self;
end;

function Tvalue.vsub(operand :Tvalue) : Tvalue;
begin
Inc(sumcounter);
case datatype of
  Tinteger: i := i - operand.i;
  Textended: e := e - operand.e;
  Tinterval: v := isub(v, operand.v);
end;
Result := self;
end;

function Tvalue.omul(operand :Tvalue) : Tvalue;
var tmpout :Tvalue;
begin
tmpout := Tvalue.Create(self);
Result := tmpout.vmul(operand);
end;

function Tvalue.odiv(operand :Tvalue) : Tvalue;
var tmpout :Tvalue;
begin
tmpout := Tvalue.Create(self);
Result := tmpout.vdiv(operand);
end;

function Tvalue.oadd(operand :Tvalue) : Tvalue;
var tmpout :Tvalue;
begin
tmpout := Tvalue.Create(self);
Result := tmpout.vadd(operand);
end;

function Tvalue.osub(operand :Tvalue) : Tvalue;
var tmpout :Tvalue;
begin
tmpout := Tvalue.Create(self);
Result := tmpout.vsub(operand);
end;

// podstawowe relacje
function Tvalue.equal(operand :Tvalue) :boolean;
begin
case datatype of
  Tinteger: Result := (i = operand.i);
  Textended: Result := (e = operand.e);
  Tinterval: Result := false;
  else Result := false;
end;
end;

function Tvalue.greaterthan(operand :Tvalue) :boolean;
begin
case datatype of
  Tinteger: Result := (i > operand.i);
  Textended: Result := (e > operand.e);
  Tinterval: Result := v.b > operand.v.b;
  else Result := false;
end;
end;

function Tvalue.lowerthan(operand :Tvalue) :boolean;
begin
case datatype of
  Tinteger: Result := (i < operand.i);
  Textended: Result := (e < operand.e);
  Tinterval: Result := v.a < operand.v.a;
  else Result := false;
end;
end;

function Tvalue.greaterequal(operand :Tvalue) :boolean;
begin
case datatype of
  Tinteger: Result := (i >= operand.i);
  Textended: Result := (e >= operand.e);
//  Tinterval: v := ;
  else Result := false;
end;
end;

function Tvalue.lowerequal(operand :Tvalue) :boolean;
begin
case datatype of
  Tinteger: Result := (i <= operand.i);
  Textended: Result := (e <= operand.e);
//  Tinterval: v := ;
  else Result := false;
end;
end;

// konstruktory
constructor Tvalue.Create(e :extended);
begin
datatype := Textended;
self.e := e;
end;

constructor Tvalue.Create(v :interval);
begin
datatype := Tinterval;
self.v := v;
end;

constructor Tvalue.Create(i :integer);
begin
datatype := Tinteger;
self.i := i;
end;

function Tvalue.Read(s :string) :Tvalue;
begin
case datatype of
  Tinteger: self.i := strtoint(s);
  Textended: self.e := strtofloat(s);
  Tinterval:
    begin
    if Pos('[', s)>0 then
      begin
      self.v.a := StrToFloat(Copy(s, Pos('[', s)+1, Pos('0', s)-1));
      self.v.b := StrToFloat(Copy(s, Pos(' ', s)+1, Pos(']', s)-1));
      end
    else
      self.v := int_read(s);
    end;
end;
Result := self;
end;

constructor Tvalue.Create(data :string);
begin
{
if (Pos('E', data)>0) or (Pos('e', data)>0) then
  datatype := Tinterval;
else}
if (Pos(',', data)>0) or (Pos('.', data)>0) then
  datatype := Textended
else
  datatype := Tinteger;
Read(data);
end;

constructor Tvalue.Create(operand :Tvalue);
begin
self.datatype := operand.datatype;
case datatype of
  Tinteger: self.i := operand.i;
  Textended: self.e := operand.e;
  Tinterval: self.v := operand.v;
end;
end;

constructor Tvalue.Create(vtype :Tdatatype);
begin
self.datatype := vtype;
self.i := 0;
self.e := 0;
self.v.a := 0;
self.v.b := 0;
end;

function Tvalue.Random(wykmin :integer; wykmax :integer) :Tvalue;
var randval, sign :Extended;
    tmpstr :string;
begin
if System.Random>0.5 then
  sign := 1
else
  sign := -1;

randval := power(10, System.random(Abs(wykmax-wykmin))+wykmin);
randval := sign * System.random * 10 * randval;

case datatype of
  Tinteger:
      self.i := round(randval);
  Textended:
      self.e := randval;
  Tinterval:
    begin
    tmpstr := FloatToStr(randval);
    self.v := int_read(tmpstr);
    end;
end;
result := self;
end;

function Tvalue.toString :string;
var a, b :string;
begin
case datatype of
  Tinteger: Result := IntToStr(self.i);
  Textended: Result := FloatToStr(self.e);
  Tinterval:
    begin
    iends_to_strings(self.v, a, b);
    Result := '['+a+' '+b+']';
    end;
end;
end;

// * * * * * * * * * * * * * *
// * * * * * * * * * * * * * *
// Tmatrix
// * * * * * * * * * * * * * *
// * * * * * * * * * * * * * *

function Tmatrix.matrixwidth :integer;
var lowest :integer;
begin
lowest := Low(items);
Result := High(items[lowest]) - Low(items[lowest]) + 1;
end;

function Tmatrix.matrixheight :integer;
begin
Result := High(items) - Low(items) + 1;
end;

function Tmatrix.matrixvtype :Tdatatype;
begin
Result := items[Low(items), Low(items[Low(items)])].datatype;
end;

function Tmatrix.mmul(operand :Tmatrix) : Tmatrix;
var i, j, k :integer;
    new :Tmatrix;
begin
if (self.width <> operand.height) then
  raise Exception.Create('Mnozenie macierzy o zlych wymiarach')
else
  begin
  new := Tmatrix.Create(self.height, operand.width, self.vtype);
  for i := Low(items) to High(items) do
    for j := Low(items[i]) to High(items[i]) do
      begin
        for k := Low(items[i]) to High(items[i]) do
          new.items[i, j].vadd(self.items[i, k].omul(operand.items[k, j]));
      end;
  Result := new;
  end;
end;

function Tmatrix.mmul(operand :Tvalue) : Tmatrix;
var i, j :integer;
begin
for i := Low(items) to High(items) do
  for j := Low(items[i]) to High(items[i]) do
    items[i, j].vmul(operand);
Result := self;
end;

function Tmatrix.madd(operand :Tmatrix) : Tmatrix;
var i, j :integer;
begin
for i := Low(items) to High(items) do
  for j := Low(items[i]) to High(items[i]) do
    items[i, j].vadd(operand.items[i, j]);
Result := self;
end;

function Tmatrix.msub(operand :Tmatrix) : Tmatrix;
var i, j :integer;
begin
for i := Low(items) to High(items) do
  for j := Low(items[i]) to High(items[i]) do
    items[i, j].vsub(operand.items[i, j]);
Result := self;
end;

function Tmatrix.zamien_wiersze(rowA, rowB :integer) :Tmatrix;
var tmp :Tvalue;
var i :integer;
begin
if rowA<>rowB then
  begin
  tmp := Tvalue.Create(self.vtype);
  for i := 0 to self.width-1 do
    begin
    tmp.setval(self.items[rowA, i]);
    self.items[rowA, i].setval(self.items[rowB, i]);
    self.items[rowB, i].setval(tmp);
    end;
  end;
  Result := self;
end;

function Tmatrix.odwroc(var det :Tvalue) :Tmatrix;
var Lk :Tmatrix;
    i, j, k :integer;
    tmp :Tvalue;
    zero, minus_one, one :Tvalue;
begin
zero := Tvalue.Create(self.vtype);
zero.setval(0);
minus_one := Tvalue.Create(self.vtype);
minus_one.setval(-1);
one := Tvalue.Create(self.vtype);
one.setval(1);

if self.height<>self.width then
  Result := nil
else
  begin
  // L - na poczatku macierz jednostkowa
  L := Tmatrix.Create(self.height, self.width, self.vtype);
  L.I;

  U := Tmatrix.Create(self);

  Lk := Tmatrix.Create(self.height, self.width, self.vtype);

  for i := 0 to High(self.items)-1 do // dla kazdej kolumny, oprocz ostatniej
    begin
      Lk.I;
      tmp := Tvalue.Create(U.items[i, i].omul(minus_one));
      if tmp.equal(zero) then
        begin
        det.setval(0);
        raise Exception.Create('Macierz nieosobliwa. Kolumna z samymi zerami');
        end;

      for j := i+1 to U.height-1 do
        Lk.items[j, i].setval(U.items[j, i].odiv(tmp));

      L := Lk.mmul(L);
      U := Lk.mmul(U);
    end;

    {
  Form1.pokazmacierz(U);
  showmessage('Macierz U');

  Form1.pokazmacierz(L);
  showmessage('Macierz L^-1');
     }

  // obliczenie wyznacznika
  det.setval(1);
  for i := 0 to U.height-1 do
    det.vmul(U.items[i, i]);

  // odwroc macierz U do U^-1
  for k := 0 to a.height-1 do
    begin
    U.items[k, k].setval(one.odiv(U.items[k, k]));
    for j := k+1 to a.width-1 do
      begin
        tmp.setval(zero);
        for i := k to j-1 do
          tmp.vsub(U.items[k, i].omul(U.items[i, j]));
        U.items[k, j].setval(tmp.odiv(U.items[j, j]));
      end;
    end;

  Result := U.mmul(L);
  end;
end;

function Tmatrix.wyznacznik_metszkolna :Tvalue;
var i, j, k :integer;
  det, tmp :Tvalue;
begin
det := Tvalue.Create(a.vtype);
tmp := Tvalue.Create(a.vtype);

if a.width<>a.height then
  begin
  showmessage('Wyznacznik tylko dla macierzy kwadratowej');
  Result := nil;
  end
else if a.width=2 then
  begin
  det.setval(a.items[0, 0]);
  det.vmul(a.items[1,1]);
  tmp.setval(a.items[0, 1]);
  tmp.vmul(a.items[1, 0]);
  det.vsub(tmp);
  Result := det;
  end
else
  begin
  for j := 0 to a.width-1 do
    begin
    k := j;
    tmp.setval(a.items[0, j]);
    for i := 1 to a.height-1 do
      begin
        k := (k+1) mod a.width;
        tmp.vmul(a.items[i, k]);
      end;
    det.vadd(tmp);
    end;

  for j := 0 to a.width-1 do
    begin
    k := j;
    tmp.setval(a.items[0, j]);
    for i := 1 to a.height-1 do
      begin
        k := (k+a.width-1) mod a.width;
        tmp.vmul(a.items[i, k]);
      end;
    det.vsub(tmp);
    end;
  Result := det;
  end;

end;

constructor Tmatrix.Create(orig :Tmatrix);
var i, j :integer;
begin
if self<>nil then
  self := Tmatrix.Create(orig.height, orig.width, orig.vtype);
for i := Low(orig.items) to High(orig.items) do
  for j := Low(orig.items[i]) to High (orig.items[i]) do
    if self.items[i, j]=nil then
      self.items[i, j] := Tvalue.Create(orig.items[i, j])
    else
      self.items[i, j].setval(orig.items[i, j]);
end;

constructor Tmatrix.Create(height: integer; width :integer; vtype :Tdatatype);
var i, j :integer;
begin
SetLength(self.items, height, width);
for i := Low(items) to High(items) do
  for j := Low(items[i]) to High(items[i]) do
      items[i, j] := Tvalue.Create(vtype);
end;

procedure Tmatrix.dopliku(nazwa :string);
var wy :TextFile;
    i, j, vtype :integer;
    a     :Integer;
    b     :Extended;
    v     :Interval;
begin
AssignFile(wy, nazwa);
Rewrite(wy);
case self.vtype of
  Tinteger:  vtype := 1;
  Textended: vtype := 2;
  Tinterval: vtype := 3;
end;
Writeln(wy, self.height, ' ', self.width, ' ', vtype);
for i := 0 to height-1 do
  begin
  for j := 0 to width-1 do
    write(wy, self.items[i, j].toString+' ');
  end;
CloseFile(wy);
end;

procedure Tmatrix.doplikuderive(nazwa :string);
var wy :TextFile;
    i, j, vtype :integer;
    a     :Integer;
    b     :Extended;
    v     :Interval;
    s     :string;
    counter :Integer;
begin
AssignFile(wy, nazwa);
Rewrite(wy);
write(wy, '[');
counter := 0;
for i := 0 to height-1 do
  begin
  write(wy, '[');
  for j := 0 to width-1 do
    begin
    if self.vtype=Tinterval then
      s := FloatToStr(self.items[i, j].v.a)
    else
      s := self.items[i, j].toString;
    s := StringReplace(s, 'E', '*10^', [rfReplaceAll, rfIgnoreCase]);
    if Pos(',', s)>0 then
      s[Pos(',', s)] := '.';
    if Pos(',', s)>0 then
      s[Pos(',', s)] := '.';
    write(wy, s);
    if (j<width-1) then
      writeln(wy, ',~');
    end;
  write(wy, ']');
  if i<height-1 then
    write(wy, ',');
  end;
write(wy, ']');
CloseFile(wy);
end;

constructor Tmatrix.Create(nazwapliku :string);
var we :TextFile;
    i, j, width, height, vtypenum :integer;
    a     :Integer;
    b     :Extended;
    v     :Interval;
    vtype :Tdatatype;
begin
AssignFile(we, nazwapliku);
Reset(we);
Readln(we, height, width, vtypenum);
case vtypenum of
  1: vtype := Tinteger;
  2: vtype := Textended;
  3: vtype := Tinterval;
end;
self := Tmatrix.Create(height, width, vtype);
for i := 0 to height-1 do
  begin
  for j := 0 to width-1 do
    begin
      case vtype of
        Tinteger:
          begin
          read(we, a);
          self.items[i, j] := Tvalue.Create(a);
          end;
        Textended:
          begin
          read(we, b);
          self.items[i, j] := Tvalue.Create(b);
          end;
        Tinterval:
          begin
          read(we, v.a, v.b);
          self.items[i, j] := Tvalue.Create(v);
          end;
      end;
    end;
  end;
CloseFile(we);
end;

constructor Tmatrix.CreateRandom(height :integer; width :integer; vtype :Tdatatype;
                    wykmin :integer; wykmax :integer);
var i, j :integer;
begin
self := Tmatrix.Create(height, width, vtype);
for i := Low(items) to High(items) do
  for j := Low(items[i]) to High(items[i]) do
    items[i, j].Random(wykmin, wykmax);
end;

function Tmatrix.I :Tmatrix;
var i, j :integer;
zero, one :Tvalue;
begin
if self<>nil then
  begin
  zero := Tvalue.Create(self.vtype);
  one := Tvalue.Create(self.vtype);
  zero.setval(0);
  one.setval(1);

  for i := 0 to self.height-1 do
    for j := 0 to self.width-1 do
      if i=j then
        self.items[i,j].setval(one)
      else
        self.items[i,j].setval(zero);
  end;
Result := self;
end;

procedure TForm1.pokazmacierz;
begin
pokazmacierz(A);
MacierzA1.Checked := true;
end;

procedure TForm1.pokazmacierz(a :Tmatrix);
var i, j :integer;
  MaxLen :integer;
begin
if (a<>nil) then
begin
current := Tmatrix.Create(a);
m.Visible := true;
m.RowCount := a.height+1;
m.ColCount := a.width+1;
m.FixedCols := 1;
m.FixedRows := 1;

m.Cells[0, 0] := 'A[i, j]';
for i := 0 to a.height-1 do
  begin
  m.Cells[0, i+1] := 'A['+IntToStr(i)+', j]';
  for j := 0 to a.width-1 do
    begin
    if i=0 then
      m.Cells[j+1, 0] := 'A[i, '+IntToStr(j)+']';
    m.Cells[j+1, i+1] := a.items[i, j].toString;
    end;
  end;
end;

for i := 1 to m.ColCount-1 do
  begin
  maxlen := 3;
  for j := 1 to m.RowCount-1 do
    if Length(m.Cells[i, j])>maxlen then
      maxlen := Length(m.Cells[i, j]);
  m.ColWidths[i] := Round(maxlen*6.5);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Randomize;
end;

procedure TForm1.Button3Click(Sender: TObject);
var v :Tvalue;
    b,c :Tmatrix;
begin
v := Tvalue.Create(Textended);
v.setval(2);
b := Tmatrix.Create(a);
c := a.mmul(b);
a := Tmatrix.Create(c);
end;

procedure TForm1.Jednostkowa1Click(Sender: TObject);
var v :Tvalue;
    i :integer;
begin
if a=nil then
  showmessage('Utworz nowa macierz')
else
  begin
  v := Tvalue.Create(a.matrixvtype);
  if a<>nil then
    begin
    v.setval(0);
    a.mmul(v);
    v.setval(1);
    for i :=Low(a.items) to High(a.items) do
      if High(a.items[i])>= i then
        a.items[i, i].setval(v);
    end;
  pokazmacierz;
  end;
end;

procedure TForm1.Diagonalna1Click(Sender: TObject);
var i, j :integer;
begin
if a=nil then
  showmessage('Utworz nowa macierz')
else
  begin
  for i := Low(a.items) to High(a.items) do
    for j := Low(a.items[i]) to High (a.items[i]) do
      if i<>j then
        a.items[i, j].setval(0);
  pokazmacierz;
  end;
end;

procedure TForm1.Gornotrojkatna1Click(Sender: TObject);
var i, j :integer;
begin
if a=nil then
  showmessage('Utworz nowa macierz')
else
  begin
  for i := Low(a.items) to High(a.items) do
    for j := Low(a.items[i]) to High (a.items[i]) do
      if i>j then
        a.items[i, j].setval(0);
  pokazmacierz;
  end;
end;

procedure TForm1.Dolnotrojkatna1Click(Sender: TObject);
var i, j :integer;
begin
if a=nil then
  showmessage('Utworz nowa macierz')
else
  begin
  for i := Low(a.items) to High(a.items) do
    for j := Low(a.items[i]) to High (a.items[i]) do
      if i<j then
        a.items[i, j].setval(0);
  pokazmacierz;
  end;
end;

procedure TForm1.Zpliku1Click(Sender: TObject);
begin
if plik.Execute then
  begin
  a := Tmatrix.Create(plik.FileName);
  Ainv := Tmatrix.Create(A.height, A.width, A.vtype);
  L := Tmatrix.Create(A.height, A.width, A.vtype);
  U := Tmatrix.Create(A.height, A.width, A.vtype);
  AAinv := Tmatrix.Create(A.height, A.width, A.vtype);
  pokazmacierz;
  end;
end;

procedure TForm1.Nowa1Click(Sender: TObject);
var h, w :integer;
  vt :Tdatatype;
begin
if nowa_dialog.ShowModal = mrOk then
  with nowa_dialog do
  begin
    h := StrToInt(nowa_h.Text);
    w := StrToInt(nowa_w.Text);
    case nowa_vt.ItemIndex of
      0: vt := Tinteger;
      1: vt := Textended;
      2: vt := Tinterval;
    end;
    A := Tmatrix.Create(h, w, vt);
    Ainv := Tmatrix.Create(A);
    L := Tmatrix.Create(A);
    U := Tmatrix.Create(A);
    AAinv := Tmatrix.Create(A);
    pokazmacierz;
  end;
end;

procedure TForm1.Losowa1Click(Sender: TObject);
var h, w, wykmin, wykmax :integer;
  vt :Tdatatype;
begin
if losowa_dialog.ShowModal = mrOk then
  with losowa_dialog do
  begin
    h := StrToInt(losowa_h.Text);
    w := StrToInt(losowa_w.Text);
    wykmin := StrToInt(losowa_wykmin.Text);
    wykmax := StrToInt(losowa_wykmax.Text);

    case losowa_vt.ItemIndex of
      0: vt := Tinteger;
      1: vt := Textended;
      2: vt := Tinterval;
    end;

    try
      a := Tmatrix.CreateRandom(h, w, vt, wykmin, wykmax);
    except
      on EInvalidOp do
        showmessage('Blad podczas losowania liczb. Przekroczono zakres typu. Wybierz mniejsze wykladniki, lub bardziej pojemny typ danych');
    end;
    Ainv := Tmatrix.Create(h, w, vt);
    L := Tmatrix.Create(h, w, vt);
    U := Tmatrix.Create(h, w, vt);
    AAinv := Tmatrix.Create(h, w, vt);

    pokazmacierz;
  end;
end;

procedure TForm1.Zakoncz1Click(Sender: TObject);
begin
application.Terminate;
end;

procedure TForm1.Oprogramie1Click(Sender: TObject);
begin
oprogramie.Show;
end;

procedure TForm1.Metodaszkolna1Click(Sender: TObject);
var wynik :Tvalue;
begin
if a<>nil then
  begin
  zero_counters;
  wynik := a.wyznacznik_metszkolna;
  end;

if wynik<>nil then
  begin
  with dialog_wyznacznik.wynik.Lines do
    begin
    Clear;
    Add('Wyznacznik macierzy');
    Add('detA = '+wynik.toString);
    Add('');
    Add('Liczba dodawan/odejmowan = '+IntToStr(sumcounter));
    Add('Liczba mnozen = '+IntToStr(mulcounter));
    Add('Liczba blednych mnozen = '+IntToStr(errmulcounter));
    end;
  dialog_wyznacznik.Show;
  end;
end;

procedure TForm1.mSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: String);
begin
if Value<>'' then
  try
    strtofloat(Value);
    a.items[ARow-1, ACol-1].Read(Value);
  except
    on EConvertError do ;
  end;
end;

procedure TForm1.Odswiez1Click(Sender: TObject);
begin
pokazmacierz;
end;

procedure TForm1.Zapisz1Click(Sender: TObject);
begin
if (a<>nil) and (zapisz_plik.Execute) then
  current.dopliku(zapisz_plik.FileName);
end;

procedure TForm1.ZapiszdoDerive1Click(Sender: TObject);
begin
if (a<>nil) and (zapisz_plik.Execute) then
  current.doplikuderive(zapisz_plik.FileName);
end;

procedure TForm1.Przezrozkladnaczynnikitrojkatne1Click(Sender: TObject);
var det, zero, one, minus_one :Tvalue;
    cmpval, blad, blad_max :Tvalue;
    i, j :integer;
begin
if a<>nil then
  begin
  zero_counters;

  zero := Tvalue.Create(a.vtype);
  one := Tvalue.Create(a.vtype);
  minus_one := Tvalue.Create(a.vtype);
  minus_one.setval(-1);
  zero.setval(0);
  one.setval(1);

  blad := Tvalue.Create(a.vtype);
  blad.setval(zero);
  blad_max := Tvalue.Create(a.vtype);
  blad_max.setval(zero);

  det := Tvalue.Create(a.vtype);
  Ainv := A.odwroc(det);
  if Ainv<>nil then
    begin
    AAinv := A.mmul(Ainv);

    for i := 0 to AAinv.height-1 do
      for j := 0 to AAinv.width-1 do
        begin
        if i=j then
          cmpval := one
        else
          cmpval := zero;

        blad := AAinv.items[i, j].osub(cmpval);
        if blad.greaterthan(blad_max) then
          blad_max.setval(blad)
        else
          begin
          blad.vmul(minus_one);
          if blad.greaterthan(blad_max) then
            blad_max.setval(blad);
          end;
        end;

    pokazmacierz(Ainv);
    MacierzA11.Checked := true;
    showmessage('Macierz odwrocona');

    with dialog_wyznacznik.wynik.Lines do
      begin
        Clear;
        Add('detA = '+det.toString);
        if det.datatype = Tinterval then
          Add('Szerokosc przedzialu detA = '+FloatToStr(int_width(det.v)));
        Add('');
        Add('Liczba dodawan/odejmowan = '+IntToStr(sumcounter));
        Add('Liczba mnozen = '+IntToStr(mulcounter));
        Add('Liczba blednych mnozen = '+IntToStr(errmulcounter));
        Add('');
        Add('Max blad bezwzgledny = '+blad_max.toString);
        if blad_max.datatype = Tinterval then
          Add('Szerokosc przedzialu bledu bezwzgl = '+FloatToStr(int_width(blad_max.v)));
      end;
    dialog_wyznacznik.Show;
    end
  else
    begin
    pokazmacierz;
    showmessage('Macierz nie ma macierzy odwrotnej');
    end;
  end;
end;

procedure TForm1.MacierzA1Click(Sender: TObject);
begin
MacierzA1.Checked := true;
pokazmacierz(A);
end;

procedure TForm1.MacierzA11Click(Sender: TObject);
begin
MacierzA11.Checked := true;
pokazmacierz(Ainv);
end;

procedure TForm1.MacierzL11Click(Sender: TObject);
begin
MacierzL11.Checked := true;
pokazmacierz(L);
end;

procedure TForm1.MacierzU1Click(Sender: TObject);
begin
MacierzU1.Checked := true;
pokazmacierz(U);
end;

procedure TForm1.AA11Click(Sender: TObject);
begin
AA11.Checked := true;
pokazmacierz(AAinv);
end;

procedure TForm1.est1Click(Sender: TObject);
begin
Form6.ShowModal;
end;

end.
