/*
projekt na grafik komputerow

  Katarzyna Rafalska (66305)
  Jacek Pospychaa (66301)

*/

#include <GL/glut.h>    // Header File For The GLUT Library 
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
#include <unistd.h>     // Header file for sleeping.
#include <stdlib.h>
#include <stdio.h>

#include "flipper_code.h"

/* The number of our GLUT window */
extern int window; 
extern list_t *ents;

int main(int argc, char **argv) 
{  
  int w=800, h=600;

  ents = read_dxf("flipper.dxf");
  if (ents == NULL)
    {
      printf("Failed to open flipper.dxf\n");
      return 1;
    }

  /* Initialize GLUT state - glut will take any command line arguments that pertain to it or 
     X Windows - look at its documentation at http://reality.sgi.com/mjk/spec3/spec3.html */  
  glutInit(&argc, argv);  

  /* Select type of Display mode:   
     Double buffer 
     RGBA color
     Alpha components supported 
     Depth buffer */  
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_ALPHA | GLUT_DEPTH);  

  /* get a window */
  glutInitWindowSize(w, h);  

  /* the window starts at the upper left corner of the screen */
  glutInitWindowPosition(0, 0);  

  /* Open a window */  
  window = glutCreateWindow("Flipper");  

  /* Register the function to do all our OpenGL drawing. */
  glutDisplayFunc(&DrawGLScene);  

  /* Go fullscreen.  This is as soon as possible. */
  //  glutFullScreen();

  /* Even if there are no events, redraw our gl scene. */
  glutIdleFunc(&IdleStuff);

  /* Register the function called when our window is resized. */
  glutReshapeFunc(&ReSizeGLScene);

  /* Register the function called when the keyboard is pressed. */
  glutKeyboardFunc(&keyPressed);

  glutMouseFunc(&mouseProc);
  glutMotionFunc (&mouseMotion);

  /* Initialize our window. */
  InitGL(w, h);
  
  /* Start Event Processing Engine */  
  glutMainLoop();  

  return 1;
}
