#include <vector>
#include <fstream>
#include <string>

using namespace std;

class CRaport;
class CStatystyka;
class CWartosc;

class CDane
{
protected:
  char* NazwaPliku;
  int TypPliku;
  CRaport* Raport;
  CStatystyka* Statystyka;
  vector <CWartosc*> Wartosc;
public:
  void CzytajDane();
  void ZapiszDane(fstream* a);
  void SetNazwaPliku(string nazwa) {};
  vector <CWartosc*>* GetWektorDanych() {};
  CDane() {};
  ~CDane() {};
};

class CRaport
{
protected:
  string NazwaPliku;
  bool ZapisacDane;
  int Precyzja;
  CDane* Dane;
  CStatystyka* Statystyka;
public:
  void ZapiszRaport();
  void SetZapisacDane(bool x) {};
  void SetPrecyzja(int x) {};
  CRaport();
  ~CRaport();
};

class CStatystyka
{
protected:
  CDane* Dane;
  CRaport* Raport;
public:
  virtual void ZapiszStatystyka(fstream*);
  virtual void Oblicz();
  CStatystyka() {};
  ~CStatystyka() {};
};

class CSredniaArytmetyczna : public CStatystyka
{
protected:
  double WartoscStatystyki;
public:
  void ZapiszStatystyka(fstream*) {};
  int Oblicz() {};
  CSredniaArytmetyczna() {};
  ~CSredniaArytmetyczna() {};
};

class CSredniaLiczbaWartosci : public CStatystyka
{
protected:
  double WartoscStatystyki;
public:
  void ZapiszStatystyka(fstream*) {};
  void Oblicz() {};
  CSredniaLiczbaWartosci() {};
  ~CSredniaLiczbaWartosci() {};
};

class CWartosc
{
protected:
  CDane* Dane;
public:
  virtual void ZapiszWartosc(fstream*);
  virtual void CzytajWartosc(fstream*);
  virtual int KonwertujDoInt();
  virtual string KonwertujDoString();
  CWartosc() {};
  ~CWartosc() {};
};

class CWartoscNominalna : public CWartosc
{
protected:
  string Wartosc;
public:
  void ZapiszWartosc(fstream*) {};
  void CzytajWartosc(fstream*) {};
  int KonwertujDoInt() {};
  string KonwertujDoString() {};
  CWartoscNominalna() {};
  ~CWartoscNominalna() {};
};

class CWartoscLiczbowa : public CWartosc
{
protected:
  int Wartosc;
public:
  void ZapiszWartosc(fstream*) {};
  void CzytajWartosc(fstream*) {};
  int KonwertujDoInt() {};
  string KonwertujDoString() {};
  CWartoscLiczbowa() {};
  ~CWartoscLiczbowa() {};
};

/* ******************************************* */
/* ****I m p l e m e n t a c j a************** */
/* ******************************************* */

void CDane::CzytajDane()
{
  fstream plik(NazwaPliku, ios::in);
  while (! plik.eof())
    {
      Wartosc.push_back(nowa_wartosc);
      nowa_wartosc->CzytajWartosc(&plik);
      i++;
    }
  plik.close();
};

void CDane::ZapiszDane(fstream* a)
{
  for (int i =0; i < Wartosc.size(); i++)
    {
      Wartosc[i].ZapiszWartosc(a);
    }
}

void CRaport::ZapiszRaport()
{
  fstream plik(NazwaPliku, ios::in);
  plik << "Raport" << endl;
  Dane->ZapiszDane(plik);
  ZapiszStatystyka(plik);
  plik.close();
}

int CSredniaArytmetyczna::Oblicz()
{
  int suma = 0;
  vector <CWartosc*> kopia_danych = Dane->GetWektorDanych();
  for (int i=0; i<kopia_danych.size(); i++)
    {
      suma = suma + kopia_danych[i].KonwertujDoInt();
    }
  return suma / kopia_danych.size();
}


/* main */
int main(void)
{
}
