#include <stdio.h>
#include "struktury.h"

int best_ever_lmax = 0;

/*
  oblicza lmax dla zadan podanych w parametrach. mozna okreslic czas poczatkowy, oraz
  gdzie ma byc zapamietany ostateczny czas zakonczenia wszystkich zadan
  {
  przydziela do procesorow i oblicza opoznienie jednoczesnie i 
  pamieta najw.opoznienie
  }
*/
int lmaxfunc(int ltasks,struct dane *wejscie, int start_time, int *end_time)
{
  int i,lmax,pr;
  struct procesor procesory[3];
  bzero(procesory, sizeof(struct procesor)*3);
  for (i=0; i<3; i++)
    procesory[i].wolny_od = start_time;

  for (i=0;i<ltasks;i++) 
    {
      przydziel_procesor(procesory, &wejscie[i]);
      //    printf("%d ", wejscie[i].num);
      if (i==0 || wejscie[i].l>lmax) {lmax=wejscie[i].l; }
      //   printf("(%d,%d,%d,%d)[%d,%d] ", wejscie[i].num, wejscie[i].c, wejscie[i].d, wejscie[i].l, pr, procesory[pr].wolny_od);
      //   printf("zad (%d,%d,%d,%d) do proc %d\n", wejscie[i].num, wejscie[i].c, wejscie[i].d, wejscie[i].l, pr);
    }

  if (end_time!=NULL)
    for (i=0; i<3; i++)
      if (i==0 || *end_time>procesory[i].wolny_od)
	*end_time = procesory[i].wolny_od;

  //  printf(" wynik %d\n", lmax);
  // stan(wejscie, lproc, ltasks);
  return lmax;
}

/* permut(wejscie) 
   wejscie - tablica z zadaniami do przydzielenia
   size - liczba zadan pozostajaca do przydzielenia
   buf - bufor z zadaniami przydzielonymi
   ltasks - liczba zadan
   zwraca lmax
*/
int permut(struct dane *wejscie, int wesize, struct dane *buf, int ltasks)
{
    int i, tmpl, l, l2, lmax, end_time;
    struct dane* tmpwe;
    //    struct dane tmp;

    if (ltasks-wesize>0) // jesli juz przydzielono jakies zadania i bedzie z czego wyliczyc lmax
      {
	//	printf("lmaxfunc\n");
	lmax = lmaxfunc(ltasks-wesize, buf, 0, &end_time); // lmax wybranych

	if (lmax >= best_ever_lmax) // jesli jest gorzej niz najlepszy wynik, nie szukaj dalej, tylko zwroc jak jest (UB1)
	  {
	    //	    printf("leaving at level %d of %d UB1\n", ltasks-wesize, ltasks);
	    return lmax;
	  }

	if(wesize==0) // jesli nie ma wiecej zadan do uporzadkowania
	  {
	    //    for (i=0; i<ltasks; i++)
	    //  printf("%d ", buf[i].num);
	    //printf("wynik %d\n", lmax);
	    if (lmax<best_ever_lmax)
	      {
		best_ever_lmax = lmax;
	      }
	    return lmax;
	  }
      }

    for (i=0; i<wesize; i++) // oblicz najgorsze opoznienie nastepujacych zadan
      {
	tmpl = end_time + wejscie[i].c - wejscie[i].d;
	if (i==0 || tmpl>l)
	    l=tmpl;
      }

    if (l >= best_ever_lmax) //jesli najgorsze opoznienie nastepujacych zadan>= najlepszego dotychczasowego, to nie warto przegladac(LB1)
      {
	//  printf("leaving at level %d of %d LB1\n", ltasks-wesize, ltasks);
	return lmax;
      }
    
    for (i=0; i<wesize; i++)
      {
	//	printf("w buf: %d->%d, w wejscie: %d<->%d\n", wejscie[i].num, bufsize-size, wejscie[i].num, wejscie[size-1].num);
     
	memcpy(&buf[ltasks-wesize], &wejscie[i], sizeof(struct dane));
	memcpy(&wejscie[i], &wejscie[wesize-1], sizeof(struct dane));
	l = permut(wejscie, wesize-1, buf, ltasks);
	memcpy(&wejscie[wesize-1], &wejscie[i], sizeof(struct dane));
	memcpy(&wejscie[i], &buf[ltasks-wesize], sizeof(struct dane));
	if (l < lmax || i==0)
	    lmax = l;
    }
    return lmax;
}

/*
main()
*/
int main(int argc, char *argv[]) {
  struct dane *wejscie, *buf;
  int ltasks,i;
  if (argc<=1)
  {
    printf("Podaj argument\n");
    exit(1);
  }
 wejscie = pobierz_dane(argv[1],&ltasks);
 buf = (struct dane*) malloc(ltasks*sizeof(struct dane));

 quicksort_d_bezc(0, ltasks-1, wejscie);
 best_ever_lmax = lmaxfunc(ltasks, wejscie, 0, NULL);

 permut(wejscie, ltasks, buf, ltasks);

 printf("%d\n", best_ever_lmax);
 free(buf);
 free(wejscie);
 
}

