/****
   LTPS - Linux Text Presentation System
                                       ****/

#include <vector>
#include <ncurses.h>

#include "common.h"

#include "slide.h"
#include "transition.h"


Slide::Slide()
{
  type = TAG_SLIDE;
  transition = new Transition();
}

Slide::Slide(const char** attrs)
{
  int i=0;
  type = TAG_SLIDE;
  transition = NULL;

  while (attrs[i] != NULL && transition == NULL) 
    {
      if (strncmp("transition", attrs[i], 11) == 0) // transition type recognition. Add below new transitions names and classes
	{
	  i++;
	  if (attrs[i]!=NULL)
	    {
	      if (strcmp(attrs[i], "Up2Down")==0)
		transition = new Trans_Up2Down();
	      else if (strcmp(attrs[i], "Left2Right")==0)
		transition = new Trans_Left2Right();
	      else if (strcmp(attrs[i], "Center2Borders")==0)
		transition = new Trans_Center2Borders();
	      else if (strcmp(attrs[i], "MoveFromLeft")==0)
		transition = new Trans_MoveFromLeft();
	      else if (strcmp(attrs[i], "Matrix")==0)
		transition = new Trans_Matrix();
	      // ADD HERE OTHER TRANSITIONS LIKE ABOVE
	    }
	}
      i++;
    }
      
  if (transition==NULL)
    transition = new Transition();
}

Slide::~Slide()
{
}

int Slide::layers_count(void)
{
  return getmaxlayer()+1;
}

int Slide::show(int layer)
{
  char*** data;
  int key, screenw, screenh;

  getmaxyx(stdscr, screenh, screenw);

  data = getformatted(screenw, screenh, layer);

  key = transition->execute(data, screenw, screenh);

  if (key!=0)
    return key;
  else
    return getch();
}
