#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <stdarg.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <signal.h>
#include <errno.h>
#include "protocol.h"

#define MAX_FSIZE 2000

struct message Ramka;

void send();    
char* receive(int cannal);    
int readcmd(char* sarg1,char* sarg2);
int commit_login(void); 
void commit_logout(void);
void commit_share(); 
void commit_get(void);    
void commit_list(void);   
void commit_who(void);    
void commit_stat(void);   
void commit_kick(void);   
void commit_set(void);
void commit_help(int logged,char *nick);
void IntToStr(int l,char* tmp);
void prg_end(int sig);


int curr_can,srv_can;
char name[PROTO_ARGSIZE];

int main(int argc,char* argv[])
{
  int curr_cmd;

  signal(2,prg_end);
  signal(SIGKILL,prg_end);
  
   srv_can=-1;
   srv_can=msgget(SERVERID,0);
   if(srv_can==-1)
    {
     printf("Nie mozna nawiazac polaczenia z serweram\n");
     exit(-1);   
    };
    
   curr_can=-1;
   strcpy(name,"Nie Zalogowany");
   printf("\n\nWiatj w \"Kliencie GrajAs'a\".\n");
   printf("Wpisz \"help\" aby uzyskac pomoc.\n");
   
   while(1)
    {
     printf("\n[%s]",name);
     printf("Podaj komende:\t");
     fflush(stdin);Ramka.command=0;
     curr_cmd=readcmd(Ramka.argument1,Ramka.argument2);
     if(curr_cmd==0) continue;
     Ramka.command=curr_cmd;
     switch(Ramka.command)
     {
      case CMD_LOGIN :{curr_can=commit_login();break;};
      case CMD_LOGOUT:{commit_logout();break;};
      case CMD_SHARE :{commit_share();break;};
      case CMD_GET   :{commit_get();break;};
      case CMD_LIST  :{commit_list();break;};
      case CMD_WHO   :{commit_who();break;};
      case CMD_STAT  :{commit_stat();break;};   
      case CMD_KICK  :{commit_kick();break;};
      case CMD_SET   :{commit_set();break;};
      case 10        :{commit_help(curr_can,name);break;};
      case 20        :{if(curr_can!=-1)
                         {printf("Najpirew wyloguj sie.\n");
			  break;}; 
                       printf("Koniec.\n");exit(0);break;};
     };    
     
             
    };    
};

int readcmd(char* sarg1,char* sarg2)
{
    char scmd[7]={0};
    int i,last=0;
    char instr[PROTO_ARGSIZE+PROTO_ARGSIZE+7+2]={0};
    char k;
    
    for(i=0;i<PROTO_ARGSIZE;i++) //zerowanie poprz. zaw.
        {sarg1[i]=0;sarg2[i]=0;};       
    fflush(stdin);    
    while(k!=0xA) //dopuki nie wcisnieto 'Enter'
     {
      k=getwc(stdin);
//      printf("%c",k);
      instr[last++]=k;       
     };
    sscanf(instr,"%s %s %s",scmd,sarg1,sarg2);

    for(i=0;(i<7)&&(scmd[i]!=0);i++)scmd[i]|=0x20;//konwersja na male litery
    for(i=0;i<PROTO_ARGSIZE;i++) //konwersja na male litery
        {
         if(sarg1[i]!=0) sarg1[i]|=0x20;
         if(sarg2[i]!=0) sarg2[i]|=0x20;
        };       
    if(strcmp(scmd,"login")==0)return CMD_LOGIN;
    if(strcmp(scmd,"logout")==0)return CMD_LOGOUT;
    if((curr_can!=-1)&&(strcmp(scmd,"share")==0))return CMD_SHARE;
    if((curr_can!=-1)&&(strcmp(scmd,"get")==0))return CMD_GET;
    if((curr_can!=-1)&&(strcmp(scmd,"list")==0))return CMD_LIST;
    if((curr_can!=-1)&&(strcmp(scmd,"who")==0))return CMD_WHO;
    if((curr_can!=-1)&&(strcmp(scmd,"stat")==0))return CMD_STAT;
    if((curr_can!=-1)&&(strcmp(scmd,"kick")==0))return CMD_KICK;
    if((curr_can!=-1)&&(strcmp(scmd,"set")==0))return CMD_SET;
    if(strcmp(scmd,"quit")==0)return 20;
    if(strcmp(scmd,"help")==0)return 10;
    printf("Nieprawidlowa komenda\n");
    return 0;
};

int commit_login()
{
  char *txt;//[200]={0};
  int tmp,ktmp;  

  if(strcmp("",Ramka.argument1)==0)
   {
    printf("Brak argumentu: [nazwa uzytkownika]\n");
    return 1;  
   };   
  if(curr_can!=-1)
   {
    printf("Jestes juz zalogowany.\n");
    return curr_can;  
   };   

  Ramka.clientid=1;
  Ramka.partnumber=0;
  Ramka.partscount=1;
  strcpy(name,Ramka.argument1);
  
  srand((unsigned)getpid());
  tmp=-1;
  while(tmp==-1)tmp=msgget(IPC_PRIVATE,IPC_CREAT|IPC_EXCL|0644);   
 
  //IntToStr(tmp,Ramka.argument2);
  sprintf(Ramka.argument2,"%d",tmp);
  //printf("\nArg2:\t%d\t%s\n",tmp,Ramka.argument2);
  send();
  txt=receive(tmp);
  if(Ramka.command>10) 
     {
      strcpy(name,"Nie Zalogowany");
      printf("%s\n",txt);
      msgctl(tmp,IPC_RMID,NULL);
      return -1;
     };
  return tmp;         
};
void commit_logout()
{
  char *wholetxt;//[300]={0};  
  if(curr_can==-1)
   {
    printf("Nie byles zalogowany.\n");
    return;  
   };   
  Ramka.clientid=curr_can;
  Ramka.partnumber=0;
  Ramka.partscount=1;
  strcpy(name,"Nie Zalogowany");
  send();
  wholetxt=receive(curr_can);
  if(Ramka.command>10)printf("%s\n",Ramka.messagebody);
  msgctl(curr_can,IPC_RMID,NULL);
  curr_can=-1;
};
void commit_share()
{
 int plik=open(Ramka.argument1,O_RDONLY);//dodac prawa
 char* wholetxt;
 int filesize,i,j;
 int partcount=1;
 char *txt;  

 
 if(plik==-1)
  {printf("Problem z otwarciem zasobu(brak?).\n");return;};
 
 filesize=lseek(plik,0L,SEEK_END);
 if(filesize>MAX_FSIZE)
  {printf("Zbyt duzy plik.\n");return;};
 //printf("Plik:\n%d\n",filesize);
  
 wholetxt=(char*)malloc(sizeof(char)*filesize+1);
 for(i=0;i<(filesize+1);i++) wholetxt[i]=0;
 lseek(plik,0L,SEEK_SET); 
 read(plik,wholetxt,filesize);
 close(plik);
 
// printf("Odczytalem:\n%s\n",wholetxt);
 
 partcount=filesize/PROTO_MSGBODYSIZE;
 if((filesize%PROTO_MSGBODYSIZE)>0)partcount++;
 
 for(i=0;i<partcount;i++)
  {
   Ramka.clientid=curr_can;
   Ramka.partnumber=i;
   Ramka.partscount=partcount;
   for(j=0;(j<PROTO_MSGBODYSIZE);j++)
     Ramka.messagebody[j]=0;
   for(j=0;(j<PROTO_MSGBODYSIZE)&&(filesize>PROTO_MSGBODYSIZE*i+j);j++)
     Ramka.messagebody[j]=wholetxt[PROTO_MSGBODYSIZE*i+j];
   send();        
//   printf("Wyslano ramke %d z %d.\n",i+1,Ramka.partscount);  
//   printf("Tersc %d:\n%s\n",i+1,Ramka.messagebody);
  };
  
  //printf("Przygotowuje sie do odbioru.\n");
  txt=receive(curr_can);
  if(Ramka.command>10){printf("%s",txt);Ramka.command=0;return;}
    else printf("Wyslano.\n");  
};
void commit_get(void)
{
 int plik;//dodac prawa
 char *wholetxt=NULL;
 int i,j,size;
 
 
 Ramka.clientid=curr_can;
 Ramka.partnumber=0;
 Ramka.partscount=1;
 send();//tutaj ID te od msgget  

 wholetxt=receive(curr_can);
 
 if(Ramka.command>10){printf("%s",Ramka.messagebody);return;}
    else printf("Odebrano.\n");
 plik=open(Ramka.argument2,O_WRONLY|O_CREAT|0644);     
 if(plik==-1) {
  printf("Problem z zapisem danych.\n");
  return;
  };
 write(plik,wholetxt,strlen(wholetxt));
 close(plik);
};
void commit_list(void)
{
 char* wholetxt;
 int i,j;
 
 Ramka.clientid=curr_can;
 Ramka.partnumber=0;
 Ramka.partscount=1;
 send();  
 
 wholetxt=receive(curr_can);
 if(Ramka.command>10){printf("%s",Ramka.messagebody);return;}
    else {
    printf("[Nazwa urzytk.][Nazwa pliku]\n");
    printf("%s\n",wholetxt);
    };  
};
void commit_who(void)
{
 char* wholetxt;
 int i,j;
 
 Ramka.clientid=curr_can;
 Ramka.partnumber=0;
 Ramka.partscount=1;
 send();//tutaj ID te od msgget  
 
 wholetxt=receive(curr_can);
 if(Ramka.command>10){printf("%s",Ramka.messagebody);return;}
  else
  {
   printf("[Zalogowani]\n");
   printf("\n%s\n",wholetxt);
  };  
};
void commit_stat(void)
{
 char* wholetxt;
 char txt[100]={0};
 int curr,max;
 
 Ramka.clientid=curr_can;
 Ramka.partnumber=0;
 Ramka.partscount=1;
 send();//tutaj ID te od msgget  
 
 wholetxt=receive(curr_can);

 if(Ramka.command>10){printf("%s",Ramka.messagebody);return;};
 
 /*if(strcmp(name,"admin")==0)
  {
   printf("[Liczba zalogowanych][Max l. zalog]\n");
   sscanf(wholetxt,"%s\n",txt);
   printf("%s\n",txt); 
   printf("Max liczba udostepnionych plikow:\n");
   sscanf(wholetxt,"%s\n",txt);
   printf("%s\n",txt); 
   printf("Max liczba odebranych bajtowionych plikow:\n");
   sscanf(wholetxt,"%s\n",txt);
   printf("%s\n\n",txt); 
   printf("[Nazwa uzytk.][Udost. plk][Pobr. bajty]\n");
   printf("%s\n",wholetxt); 
  }else{ 
   printf("[Liczba zalogowanych][Max]\n");
   sscanf(wholetxt,"\n%s %s\n",txt);
   printf("%s\n",txt); 
   printf("[Pobr. bajty][Max]\n");
   sscanf(wholetxt,"\n%s %s\n",txt);
   printf("%s\n",txt); 
   };*/
   printf("%s\n",wholetxt); 
};
void commit_kick(void)
{
 char* wholetxt;  
 
  if(strcmp(name,"admin")!=0)
   {printf("Nieprawidlowa komenda.\n");return;};

 Ramka.clientid=curr_can;
 Ramka.partnumber=0;
 Ramka.partscount=1;
 send();  
 wholetxt=receive(curr_can);
 if(Ramka.command>10){printf("%s\n",Ramka.messagebody);return;};
 printf("Wykopalismy go.\n");
};
void commit_set(void)
{
 char* wholetxt;  

 if(strcmp(name,"admin")!=0)
  {printf("Nieprawidlowa komenda.\n");return;};
 
 Ramka.clientid=curr_can;
 Ramka.partnumber=0;
 Ramka.partscount=1;
 send();//tutaj ID te od msgget  
 wholetxt=receive(curr_can);
 if(Ramka.command>10){printf("%s\n",Ramka.messagebody);return;};
 printf("Ustawiono.\n");
};
void commit_help(int logged,char *nick)
{
 printf("AKTUALNIE Dostepne komendy:\n"
        "Napis np. [liczba] oznacza np. 4  ;]\n\n"
        "Znacznik \"n\" oznacza, to ze dany argument nie jest wymagany\n"
        "\tPolecenie zadziala wtedy inaczej (prosze przeczytac specyfikacje)\n\n");
 
 printf("quit\t- wyjscie z porgramu\n");
 if(logged==-1) printf("login [nazwa_uzytkownika]\t- nawiazanie polaczenia z serwerem\n");
   else{
       printf("logout\t- przerwanie polaczenia z serwerem\n");
       printf("share [nazwa_zasobu(plik)] n[nazwa_uzytkownika]\t- przesyla plik na serwer\n");
       printf("get [nazwa_uzytkownika] n[nazwa_zasobu]\t- pobiera plik z serwera\n");
       printf("list n[nazwa_uzytkownika]\t- wyswietla zasoby\n");
       printf("who\t- lista zalogownych\n");
       printf("stat\t- stan serwera\n");
       if(strcmp(nick,"admin")==0)
         {
          printf("kick [nazwa_uzytkownika]\t- stan serwera\n");
          printf("set [nazwa_par] [nowa_wart]\t- ustawia par. serwera\n");
         };    
       };         
};
void send(void)    
{
 int rtn=0;
 if(curr_can!=-1)
    rtn=msgrcv(curr_can,&Ramka,PROTO_MSGSIZE,2,IPC_NOWAIT);
 if( (Ramka.partscount==1)&&(rtn==-1)&&(errno!=ENOMSG) )   
 {
//  printf("<Kick>\tCurr_can:: %d\tR.cmd:: %d\n",curr_can,Ramka.command);
//  if(Ramka.command==2)
    {
     msgctl(curr_can,IPC_RMID,NULL);
     strcpy(name,"Nie Zalogowany");
     strcpy(Ramka.messagebody,"Zostales wykopany.\nMilego dnia.\nadmin\n");
     if(curr_can!=-1)msgctl(curr_can,IPC_RMID,NULL);
     curr_can=-1;
     Ramka.command+=10;
     return;
    };
 };
msgsnd(srv_can,&Ramka,PROTO_MSGSIZE,Ramka.clientid);
};
char* receive(int cannal)    
{
 int i;
 char *wholemsg;
  
 Ramka.command=0;
 msgrcv(cannal,&Ramka,PROTO_MSGSIZE,0,0);//odczyt kolejnej ramki
  wholemsg=(char*)malloc(sizeof(char)*PROTO_MSGBODYSIZE*Ramka.partscount);

// printf("<Rcv>\tCurr_can:: %d\tR.cmd:: %d\n",curr_can,Ramka.command);
 if(Ramka.command==2)
   {
    msgctl(curr_can,IPC_RMID,NULL);
    strcpy(name,"Nie Zalogowany");
    strcpy(Ramka.messagebody,"Zostales wykopany.\nMilego dnia.\nadmin\n");
    if(curr_can!=-1)msgctl(curr_can,IPC_RMID,NULL);
    curr_can=-1;
    return NULL;
   };
   
 if(Ramka.command>10) 
   {strcat(wholemsg,Ramka.messagebody);return wholemsg;};   
 for(i=0;i<Ramka.partscount;i++)
  {
   //printf("Odczytano ramke %d z %d.\n",i,Ramka.partscount-1);  
   if(i==Ramka.partnumber) 
     strcat(wholemsg,Ramka.messagebody);
    else {
     strcat(wholemsg,"Blad przy odbieraniu danych.(zly nr ramki)\n");
     return wholemsg;
     };
   if(i+1<Ramka.partscount)msgrcv(cannal,&Ramka,PROTO_MSGSIZE,0,0);//odczyt kolejnej ramki   
  };   
return wholemsg;
};

void prg_end(int sig)
{
 msgctl(curr_can,IPC_RMID,NULL);
 printf("Koniec.\n");
 exit(0);
};

