#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <stdarg.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include "protocol.h"

#define MAX_FSIZE 2000
//#define MAX_USR 10
//#define MAX_FILES 10
//#define MAX_RCV 10

struct Sfile{
 struct Sfile *Next;
 char FileName[PROTO_ARGSIZE];//oryginalna nazwa pliku  
 char Access[PROTO_ARGSIZE];//nazwa uzytkownika ktora ma dostep
                            //gdy pusta, to wszyscy
};
struct SUsr{ //glowa repr ust serwera
 int ID; //nr kanalu uzytk, w serwerze liczba akt. zalog. uzytk
 char Name[PROTO_ARGSIZE]; //nazwa uzytk
 int M_usr,Fp_usr,Sp_usr; //w glowie przech ust serw
 struct SUsr *Next,*Prev; //w glowie wsk na nast i ost el listy   
 struct Sfile *Plik;
};

struct message *Ramka;
struct SUsr *Serw;

void send(int,char*);
char* receive(int);
void commit_login(void);
void commit_logout(void);
void commit_share(void);
void commit_get(void);
void commit_list(void);
void commit_who(void);
void commit_stat(void);
void commit_kick(void);
void commit_set(void);
struct SUsr *WhoseID(int UsrID);
struct SUsr *WhoseName(char Name[PROTO_ARGSIZE]);
void prg_end(int sig);

int srv_can;

int main(int argc,char* argv[])
{
  int curr_cmd;
  int i,j;
  
  signal(2,prg_end);
  signal(SIGKILL,prg_end);
  if(argc<3){
     printf("\nSkladnia uruchamiania serwera:\n"
            "sw [max_uzytk] [max_plikow_na_uzytk] [max_odebr_ramek]\n");
     exit(-1);
     };           
  
   Serw=(struct SUsr*)malloc(sizeof(struct SUsr));
     
   Serw->M_usr=atoi(argv[1]);
   Serw->Fp_usr=atoi(argv[2]);
   Serw->Sp_usr=atoi(argv[3]);
   Serw->ID=0;
   Serw->Next=NULL;
   Serw->Plik=NULL;
   Serw->Prev=Serw;
   
   Ramka=(struct message*)malloc(sizeof(struct message));

   if(PROTO_MSGSIZE!=sizeof(struct message))
    {printf("Zadklarowany rozmiar ramki rozny od rzeczywistego rozmiaru.\n");
     printf("Zadekrarowano:%5d[B]\nJest:%5d[B]\n",PROTO_MSGSIZE,sizeof(Ramka));
     printf("Koniec programu.\n");
     exit(-1);
    }; 
        
   srv_can=msgget(SERVERID,IPC_CREAT|0666);
   if(srv_can==-1)
    {
     printf("Nie mozna zalozyc kolejki\nKoniec.\n");
     exit(-1);
    };
    
   printf("\nWitaj w programie Serwer.\n");
   printf("[Ctrl] + [C] Konczy program.\n");
   while(1)
    {
     Ramka->command=0;     
     msgrcv(srv_can,Ramka,PROTO_MSGSIZE,0,0);
     
     switch(Ramka->command)
     {
      case CMD_LOGIN :{commit_login();break;};
      case CMD_LOGOUT:{commit_logout();break;};
      case CMD_SHARE :{commit_share();break;};
      case CMD_GET   :{commit_get();break;};
      case CMD_LIST  :{commit_list();break;};
      case CMD_WHO   :{commit_who();break;};
      case CMD_STAT  :{commit_stat();break;};
      case CMD_KICK  :{commit_kick();break;};
      case CMD_SET   :{commit_set();break;};
     };
    };
};

void commit_login(void)
{
  char txt[150];
  struct SUsr *Usr=NULL,*Tmp=NULL;
  int i,j;

  if(Ramka->clientid!=1)
     {
      Usr=WhoseID(Ramka->clientid);
      Ramka->command=ERR_LOGIN;
      if (Usr!=NULL) 
       {strcpy(txt,"\n<Serwer>:Blad - jestes juz zalogowany.\n");
        send(Ramka->clientid,txt);
       };
      return;      
     };
  Ramka->clientid=atoi(Ramka->argument2);
  if(Serw->M_usr<=Serw->ID)//jezeli zostala osiagnieta max liczba uzytk
      {
       //printf("\nZostala osiagnieta max liczba Uzytkowniow\n");
       Ramka->command=ERR_LOGIN;
       strcpy(txt,"\n<Serwer>:Blad przekroczono dowolona liczbe zalogowanych uzytkownikow.\n");
       send(Ramka->clientid,txt);
       msgctl(Ramka->clientid,IPC_RMID,NULL);
       return;
      }; 
  if(WhoseName(Ramka->argument1)!=NULL)    
      {
       Ramka->command=ERR_LOGIN;
       strcpy(txt,"\n<Serwer>:Blad, taki uzytkownik juz jest zalogowany.\n");
       send(Ramka->clientid,txt);
       msgctl(Ramka->clientid,IPC_RMID,NULL);
       return;
      };
      
  Serw->ID++;  
  Usr=(struct SUsr*)malloc(sizeof(struct SUsr));
  Usr->ID=Ramka->clientid;
  Usr->Fp_usr=0;
  Usr->M_usr=0;
  strcpy(Usr->Name,Ramka->argument1);
  Usr->Next=NULL;
  Usr->Plik=NULL;
  Usr->Prev=Serw->Prev; //poprzedni to ostatni z listy
  Usr->Sp_usr=0;
  
  if(Serw->Next==NULL)
   {
    Serw->Next=Usr;
    Serw->Prev=Usr;   
   }else{ 
     Tmp=Serw->Prev;
     Serw->Prev=Usr;
     Tmp->Next=Usr;
     };
      
  strcpy(txt,"nic");
  //printf("passed1\n");
  send(Ramka->clientid,txt);
  printf("%s has joined.\tNow %d users logged in.\n",Usr->Name,Serw->ID);
};
void commit_logout(void)
{
  struct SUsr *Kl,*NKL,*PKL;
  int j;
  char txt[150]={0};

  Kl=WhoseID(Ramka->clientid);
  if(Kl==NULL)
   {
    strcpy(txt,"\n<Serwer>Blad - nie byles w spisie serwera\n");
    Ramka->command=ERR_LOGOUT; 
    send(Ramka->clientid,txt);
    msgctl(Ramka->clientid,IPC_RMID,NULL);
    return;
   };

  strcpy(txt,"\n<Serwer>Wylogowano\n");
  send(Ramka->clientid,txt);
  msgctl(Ramka->clientid,IPC_RMID,NULL);
  Serw->ID--;
  
 if(Serw->ID>0) 
  {
   PKL=Kl->Prev;
   NKL=Kl->Next;
   PKL->Next=NKL;
   if(NKL!=NULL)NKL->Prev=PKL;
   if(NKL==NULL)Serw->Prev=PKL; 
  }else if(Serw->ID==0)
    {
     Serw->Prev=Serw;
     Serw->Next=NULL;
    };    
     
  printf("%s left. Now %d logged in.\n",Kl->Name,Serw->ID);
  free(Kl);
};
void commit_share(void)
{
 char filename[PROTO_ARGSIZE+PROTO_ARGSIZE]={0};
 int plik,i,size=0;
 struct SUsr *Usr=NULL;
 struct Sfile *New=NULL,*NextF=NULL;
 char *resttxt=NULL,*wholetxt=NULL;
 char txt[PROTO_MSGBODYSIZE]={0};
 
 Ramka->command=CMD_SHARE;
 Usr=WhoseID(Ramka->clientid);
 NextF=Usr->Plik;
 while(NextF!=NULL) 
  {
   if(strcmp(NextF->FileName,Ramka->argument1)==0)
    {
     Ramka->command=ERR_SHARE;
     sprintf(txt,"<Serwer> Blad, ten plik jest juz udostepniony.\n");
     send(Ramka->clientid,txt);
     return;      
    };    
   NextF=NextF->Next;
  };

 strcat(filename,Usr->Name);
 strcat(filename,"_");
 strcat(filename,Ramka->argument1);
 //powstala nazwa pliku "[nazwa_wlascicela]_[org_nazwa_pliku]"
 
 for(i=0;i<PROTO_MSGBODYSIZE;i++)
  txt[i]=Ramka->messagebody[i];
 if(Ramka->partscount>1)
   {
    resttxt=receive(Ramka->clientid);
    size=strlen(resttxt);
    //printf("Reszta %d:\n%s\n",size,resttxt);
   }; 
 
 
 wholetxt=(char*)malloc(sizeof(char)*PROTO_MSGBODYSIZE+size+1);
 for(i=0;i<(PROTO_MSGBODYSIZE+size+1);i++) wholetxt[i]=0;
 
 strcpy(wholetxt,txt);
 for(i=0;i<PROTO_MSGBODYSIZE;i++)
  wholetxt[i]=txt[i];
 
 if(size>0) for(i=0;i<strlen(resttxt);i++)
             wholetxt[PROTO_MSGBODYSIZE+i]=resttxt[i];
 
 //if(size>0)strcat(wholetxt,resttxt);
 //printf("Odebralem1:\n%s\n",txt);
 //printf("Odebralem3:\n%s\n",wholetxt);
 
 Ramka->partscount=1;
 Ramka->partnumber=0;
 printf("Zapisuje.\n");
 plik=open(filename,O_WRONLY|O_CREAT|0666);//dodac prawa
 if(plik==-1) 
  {
   Ramka->command=ERR_SHARE;
   sprintf(txt,"<Serwer> Blad, nie moge utworzyc pliku.\n");
   send(Ramka->clientid,txt);
   return;      
  };
 write(plik,wholetxt,strlen(wholetxt));
 close(plik);
 printf("Zapisalem.\n");
 
 New=(struct Sfile*)malloc(sizeof(struct Sfile));
 strcpy(New->Access,Ramka->argument2);
 strcpy(New->FileName,Ramka->argument1);
 New->Next=NULL;
 Usr->Fp_usr++; //powieksza l. plikow udostepnionych przez uzytk
 if(Usr->Plik==NULL) 
  {Usr->Plik=New;
   sprintf(txt,"Zasob udostepniony.\n");
   send(Ramka->clientid,txt);   
   return;
  };  
 NextF=Usr->Plik;
 while(NextF->Next!=NULL) NextF=NextF->Next;
 NextF->Next=New;
 sprintf(txt,"Zasob udostepniony.\n");
 send(Ramka->clientid,txt);   
};
void commit_get(void)
{
 char filename[PROTO_ARGSIZE+PROTO_ARGSIZE]={0};
 struct SUsr *UsrR=NULL,*UsrO=NULL;//User requesing & User-owner
 struct Sfile *ReqF=NULL;
 char *wholetxt=NULL,txt[150]={0};
 int filesize,i,plik;

 //IntToStr(Ramka->clientid,sid);
 UsrR=WhoseID(Ramka->clientid);
 UsrO=WhoseName(Ramka->argument1);
 if(UsrO==NULL)
  {
   Ramka->command=ERR_GET;
   sprintf(txt,"<Serwer> Blad, zla nazwa uzytkownika wlasciciela.\n");
   send(Ramka->clientid,txt);
   return;      
  };
 
 ReqF=UsrO->Plik;
 while(ReqF!=NULL)
  {
   if(strcmp(ReqF->FileName,Ramka->argument2)==0) break;
   ReqF=ReqF->Next;
  };
 if(ReqF==NULL)
  {
   Ramka->command=ERR_GET;
   sprintf(txt,"<Serwer> Blad, nie moge znalesc pliku.\n");
   send(Ramka->clientid,txt);
   return;      
  };
 if( (strcmp(ReqF->Access,"")!=0)&&
     (strcmp(ReqF->Access,UsrR->Name)!=0) )
  {
   Ramka->command=ERR_GET;
   sprintf(txt,"<Serwer> Blad, nie masz praw potrzebnych" 
   	       "do uzyskania tego zasobu.\n");
   send(Ramka->clientid,txt);
   return;      
  };
   
 strcat(filename,Ramka->argument1);
 strcat(filename,"_");
 strcat(filename,Ramka->argument2);
 
 plik=open(filename,O_RDONLY);//dodac prawa
 if(plik==-1)
  {
   Ramka->command=ERR_GET;
   strcpy(txt,"\n<Serwer>::Blad: Brak dostepu do pliku.\n");
   send(Ramka->clientid,txt);
   return;
  };
  
 filesize=lseek(plik,0L,SEEK_END);
 if( (filesize+UsrR->Sp_usr)> Serw->Sp_usr )
  {
   Ramka->command=ERR_GET;
   strcpy(txt,"\n<Serwer>::Blad: Wyczerpales swoj limit pobran.\n");
   send(Ramka->clientid,txt);
   return;
  };
 
 wholetxt=(char*)malloc(sizeof(char)*filesize+1);
 for(i=0;i<(filesize+1);i++)wholetxt[i]=0;
 lseek(plik,0L,SEEK_SET); 
 read(plik,wholetxt,filesize);
 close(plik);
 UsrR->Sp_usr+=filesize;
 send(Ramka->clientid,wholetxt);
 //printf("Wyslalem:\n %s\n",wholetxt); 
};
void commit_list(void)
{
 char* wholetxt;
 int i,j,size;
 struct SUsr *UsrR,*Usr;
 struct Sfile *CFile;
 
 size=Serw->ID*Serw->Fp_usr*2*PROTO_ARGSIZE;
 wholetxt=(char*)malloc(sizeof(char)*size);
 
 UsrR=WhoseID(Ramka->clientid);

 Usr=Serw->Next;
 while(Usr!=NULL)
  {
   if( (strcmp(Ramka->argument1,"")==0)||
       (strcmp(Ramka->argument1,Usr->Name)==0) )
   {
    CFile=Usr->Plik;
    while(CFile!=NULL)
    {
     if((strcmp(CFile->Access,"")==0)||
        (strcmp(CFile->Access,UsrR->Name)==0) )
        {
	 strcat(wholetxt,Usr->Name);
	 strcat(wholetxt," ");
	 strcat(wholetxt,CFile->FileName);
	 strcat(wholetxt,"\n");	 
	};
      CFile=CFile->Next;
     };
    }; 
   Usr=Usr->Next; 
  };
 Ramka->clientid=UsrR->ID;
 Ramka->partnumber=0;
 Ramka->partscount=1;
 send(UsrR->ID,wholetxt);//tutaj ID te od msgget
};
void commit_who(void)
{
 struct SUsr *Usr=NULL;
 char* wholetxt;
 int i,j,size;

 size=(PROTO_ARGSIZE+1)*(Serw->ID+5);
 wholetxt=(char*)malloc(sizeof(char)*size);
 for(i=0;i<size;i++) wholetxt[i]=0;
 
  Usr=Serw->Next;
 while(Usr!=NULL)
 {
 strcat(wholetxt,Usr->Name);
 strcat(wholetxt,"\n");
 Usr=Usr->Next;    
 }; 
 send(Ramka->clientid,wholetxt);
};
void commit_stat(void)
{
 char* wholetxt=NULL;
 char txt[16];
 int curr,max;
 struct SUsr *Kl,*Usr;
 
 Kl=WhoseID(Ramka->clientid);
 Ramka->partnumber=0;
 Ramka->partscount=1;
 if(strcmp(Kl->Name,"admin")==0)
  {
   wholetxt=(char*)malloc(sizeof(char)*(3*PROTO_ARGSIZE)*(Serw->ID+3));
   sprintf(wholetxt,"x %d %d\ny %d\nz %d\n",Serw->ID,Serw->M_usr,Serw->Fp_usr,Serw->Sp_usr); 
   Usr=Serw->Next;
   while(Usr!=NULL)
   {
    strcat(wholetxt,Usr->Name);
    strcat(wholetxt," ");
    sprintf(txt,"%d %d",Usr->Fp_usr,Usr->Sp_usr);
    strcat(wholetxt,txt);
    strcat(wholetxt,"\n");
    Usr=Usr->Next;    
   };   
  }else{
   wholetxt=(char*)malloc(sizeof(char)*(3*PROTO_ARGSIZE));
   sprintf(txt,"%d %d\n",Kl->Fp_usr,Serw->Fp_usr);
   strcat(wholetxt,txt);
   sprintf(txt,"%d %d\n",Kl->Sp_usr,Serw->Sp_usr);
   strcat(wholetxt,txt);
   };
 send(Kl->ID,wholetxt);//tutaj ID te od msgget
};
void commit_kick(void)
{
 char txt[150]={0};
 struct SUsr *Kl,*NKL,*PKL,*Adm;
 
 Adm=WhoseID(Ramka->clientid);
 Kl=WhoseName(Ramka->argument1);
 if(Kl==NULL)    
      {
       Ramka->command=ERR_KICK;
       strcpy(txt,"\n<Serwer>:Blad, nie ma takiego uzytkownika.\n");
       send(Adm->ID,txt);
       msgctl(Ramka->clientid,IPC_RMID,NULL);
       return;
      };
 
      
 
 Ramka->partnumber=0;
 Ramka->partscount=1;
 strcpy(txt,"\nWykopalismy go.\n");
 send(Adm->ID,txt);
 
 strcpy(txt,"\nZostales wykopany.\nZycze milego dnia.\nadmin\n");
 Ramka->clientid=Kl->ID;
 Ramka->command=2;
 send(Kl->ID,txt);//tutaj ID te od msgget
 msgctl(Kl->ID,IPC_RMID,NULL);
 printf("%s has been kicked. ",Kl->Name);//fflush(stdout);
 
 PKL=Kl->Prev;
 NKL=Kl->Next;
 PKL->Next=NKL;
 if(NKL!=NULL)NKL->Prev=PKL;
 if(NKL==NULL)Serw->Prev=PKL;
 free(Kl);
 Serw->ID--; 
 printf("Now is %d users logged in.\n",Serw->ID); 
};
void commit_set(void)
{
 char wholetxt[150];
 int liczba=atoi(Ramka->argument2);

  if(liczba<0)
   {
    Ramka->command=ERR_SET;
    strcpy(wholetxt,"Podales nie prawidlowa liczbe.\n");
    send(Ramka->clientid,wholetxt);    
   };
  if(strcmp(Ramka->argument1,"x")==0)
  { 
   printf("Zmieniono max. liczbe zalogowanych na:\t");
   Serw->M_usr=liczba; 
  }else 
 if(strcmp(Ramka->argument1,"y")==0) 
  { 
    printf("Zmieniono max. liczbe udost. plikow na:\t");
   Serw->Fp_usr=liczba; 
  }else 
 if(strcmp(Ramka->argument1,"z")==0) 
  { 
    printf("Zmieniono max. liczbe odebranych ramek na:\t");
   Serw->Sp_usr=liczba; 
  }else
   {
    Ramka->command=ERR_SET;
    strcpy(wholetxt,"Ze co mam zmienic, cioto?\n");
    send(Ramka->clientid,wholetxt);    
   }; 
 
 printf("%d\n",liczba); 
 
 strcpy(wholetxt,"<Serw>Done.\n");
 send(Ramka->clientid,wholetxt);//tutaj ID te od msgget
};
void send(int cannal,char *wholetxt)
{
 int partcount;
 int i,j;
 
 partcount=(strlen(wholetxt)+1)/PROTO_MSGBODYSIZE;
 if(((strlen(wholetxt)+1)%PROTO_MSGBODYSIZE)>0)
     partcount++;
 
 //printf("Liczba ramek %d.\n",partcount);
     
 for(i=0;i<partcount;i++)
  {
 //  printf("Wyslano %d ramke.\n",i);
   Ramka->partnumber=i;
   Ramka->partscount=partcount;
   for(j=0;(j<PROTO_MSGBODYSIZE)&&((strlen(wholetxt)+1)>=(PROTO_MSGBODYSIZE*i+j));j++)
     Ramka->messagebody[j]=wholetxt[PROTO_MSGBODYSIZE*i+j];
  // printf("Tresc: %s\n",Ramka->messagebody);
     
   msgsnd(cannal,Ramka,PROTO_MSGSIZE,Ramka->clientid);        
  };
// msgsnd(cannal,Ramka,PROTO_MSGSIZE,Ramka->clientid);        
};
char* receive(int cannal)
{
 int i,j,size=0;
 char* wholemsg;

 size=PROTO_MSGBODYSIZE*Ramka->partscount;
 wholemsg=(char*)malloc(sizeof(char)*size+1);
 for(i=0;i<size;i++) wholemsg[i]=0;
 
 for(i=0;i<(Ramka->partscount-1);i++)
  {
   msgrcv(srv_can,Ramka,PROTO_MSGSIZE,0,0);//odczyt kolejnej ramki
   //printf("Odczytano ramke %d z %d.\n",i+1,Ramka->partscount);
   if((i+1)==Ramka->partnumber)
    {
     for(j=0;j<PROTO_MSGBODYSIZE;j++)
       wholemsg[i*PROTO_MSGBODYSIZE+j]=Ramka->messagebody[j];
     //printf("Tresc %d:\n%s\n",i+1,Ramka->messagebody);  
    }
    else 
     {
      strcat(wholemsg,"Blad przy odbieraniu danych.(zly nr ramki)\n");
      return wholemsg;
     };
   if( (i*PROTO_MSGBODYSIZE)>2000 )return wholemsg;  
  };
 return wholemsg;
};

struct SUsr* WhoseID(int UsrID)
{
 struct SUsr *Head,*Usr;

 Head=Serw;  
 Usr=Head->Next;
 while(Usr!=NULL)
 {
  if(Usr->ID==UsrID) return Usr;
  Usr=Usr->Next;   
 }; 
 return (NULL);
};
struct SUsr *WhoseName(char Name[PROTO_ARGSIZE])
{
 struct SUsr *Head=Serw,*Usr;
  
 Usr=Head->Next;
// printf("Porownuje:\n");
 while(Usr!=NULL)
 {
//  printf("%s\t%s",Usr->Name,Name);
  if(strcmp(Usr->Name,Name)==0) return Usr;
  Usr=Usr->Next;   
 };
// printf("No match\n"); 
 return (NULL);
};

void prg_end(int sig)
{
 struct SUsr *Usr;
 char txt[50]="Wylogowano.\nSerwer zakonczyl prace.\n";
 int i=0;
 
 Usr=Serw->Next;
 Ramka->command=2;
 Ramka->partscount=1;
 Ramka->partnumber=0;
 while(Usr!=NULL)
 {
  i++;
  send(Usr->ID,txt);
  msgctl(Usr->ID,IPC_RMID,NULL);
  Usr=Usr->Next;   
 }; 
 printf("Przymusowo wylogowano %d uzytkownikow.\n",i);
 
 msgctl(srv_can,IPC_RMID,NULL);
 printf("Koniec.\n");
 exit(0);
};
