#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <stdarg.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include "protocol.h"

#define MAX_FSIZE 2000
//#define MAX_USR 10
//#define MAX_FILES 10
//#define MAX_RCV 10

struct Sfile{
 struct Sfile *Next;
 char FileName[PROTO_ARGSIZE];//oryginalna nazwa pliku  
 char Access[PROTO_ARGSIZE];//nazwa uzytkownika ktora ma dostep
                            //gdy pusta, to wszyscy
};
struct SUsr{ //glowa repr ust serwera
 int ID; //nr kanalu uzytk, w serwerze liczba akt. zalog. uzytk
 char Name[PROTO_ARGSIZE]; //nazwa uzytk
 int M_usr,Fp_usr,Sp_usr; //w glowie przech ust serw
 struct SUsr *Next,*Prev; //w glowie wsk na nast i ost el listy   
 struct Sfile *Plik;
} Serw;

struct message Ramka;

void send(int,char*);
void receive(int,char*);
void commit_login(void);
void commit_logout(void);
void commit_share(void);
void commit_get(void);
void commit_list(void);
void commit_who(void);
void commit_stat(void);
void commit_kick(void);
void commit_set(void);
struct SUsr *WhoseID(int UsrID);
struct SUsr *WhoseName(char Name[PROTO_ARGSIZE]);
void IntToStr(int,char*);

int srv_can;

int main(int argc,char* argv[])
{
  int curr_cmd;
  int i,j;
  
  if(argc<3){
     printf("\nSkladnia uruchamiania serwera:\n"
            "sw [max_uzytk] [max_plikow_na_uzytk] [max_odebr_ramek]\n");
     exit(-1);
     };           
  
   Serw.M_usr=atoi(argv[1]);
   Serw.Fp_usr=atoi(argv[2]);
   Serw.Sp_usr=atoi(argv[3]);
   Serw.ID=0;
   Serw.Next=NULL;
   Serw.Plik=NULL;
   Serw.Prev=&Serw;

   if(PROTO_MSGSIZE!=sizeof(Ramka))
    {printf("Zadklarowany rozmiar ramki rozny od rzeczywistego rozmiaru.\n");
     printf("Zadekrarowano:%5d[B]\nJest:%5d[B]\n",PROTO_MSGSIZE,sizeof(Ramka));
     printf("Koniec programu.\n");
     exit(-1);
    }; 
        
   srv_can=msgget(SERVERID,IPC_CREAT|IPC_EXCL);
   if(srv_can==-1)
    {
     printf("Nie mozna zalozyc kolejki\nKoniec.\n");
     exit(-1);
    };
    
   printf("\nWitaj w programie Serwer.\n");
     printf("SeRWID_1: %d\n",Serw.ID);
   while(1)
    {     
     printf("SeRWID_2: %d\n",Serw.ID);
     msgrcv(srv_can,&Ramka,PROTO_MSGSIZE,0,0);
     printf("SeRWID_3: %d\n",Serw.ID);
     
     switch(Ramka.command)
     {
      case CMD_LOGIN :{commit_login();break;};
      case CMD_LOGOUT:{commit_logout();break;};
      case CMD_SHARE :{/*commit_share();*/break;};
      case CMD_GET   :{break;};
      case CMD_LIST  :{break;};
      case CMD_WHO   :{break;};
      case CMD_STAT  :{break;};
      case CMD_KICK  :{break;};
      case CMD_SET   :{break;};
     };
    };
};

void commit_login(void)
{
  char txt[MAX_FSIZE];
  struct SUsr *Usr=NULL,*Tmp=NULL;
  int i,j;

  if(Ramka.clientid!=1)
     {
      Usr=WhoseID(Ramka.clientid);
      Ramka.command=11;
      if (Usr!=NULL) 
       {strcpy(txt,"\n<Serwer>:Blad - jestes juz zalogowany.");
        send(Ramka.clientid,txt);
       };
      return;      
     };
  Ramka.clientid=atoi(Ramka.argument2);
  Serw.ID++;
  printf("SeRWID_a: %d\n",Serw.ID);
  printf("Kanal:\t%d\n",Ramka.clientid);
  if(Serw.M_usr==Serw.ID)//jezeli zostala osiagnieta max liczba uzytk
      {
       printf("bad1\n");
      Ramka.command=11;
      strcpy(txt,"\n<Serwer>:Blad przekroczono dowolona liczbe zalogowanych uzytkownikow.\n");
      send(Ramka.clientid,txt);
      msgctl(Ramka.clientid,IPC_RMID,NULL);
      return;
      };
  
  
  Usr=(struct SUsr*)malloc(sizeof(struct SUsr));
  Usr->ID=Ramka.clientid;
  Usr->Fp_usr=0;
  Usr->M_usr=0;
  strcpy(Usr->Name,Ramka.argument1);
  Usr->Next=NULL;
  Usr->Plik=NULL;
  Usr->Prev=Serw.Prev; //poprzedni to ostatni z listy
  Usr->Sp_usr=0;
  
  if(Serw.Next==NULL)
   {
    Serw.Next=Usr;
    Serw.Prev=Usr;   
   }else{ 
     Tmp=Serw.Prev;
     Serw.Prev=Usr;
     Tmp->Next=Usr;
     };
      
  strcpy(txt,"nic");
  //printf("passed1\n");
  send(Ramka.clientid,txt);
  printf("%s has joined.\tNow %d users logged in.\n",Usr->Name,Serw.ID);
};
void commit_logout(void)
{
  struct SUsr *Usr=NULL,*Tmp=NULL;
  int j;

  Usr=WhoseID(Ramka.clientid);
  if(Usr==NULL) return;

  send(Ramka.clientid,"\n<Serwer>Wylogowano\n");
  msgctl(Ramka.clientid,IPC_RMID,NULL);
  if(Serw.ID>0) Serw.ID--;
  Tmp=Usr->Prev;
  Serw.Prev=Tmp;//cofa wskaznik na ost pozycje o jeden w tyl
  Tmp->Next=NULL;
  
  printf("%s left.\n",Usr->Name);
  free(Usr);

};
void commit_share(void)
{
 char filename[PROTO_ARGSIZE+PROTO_ARGSIZE]={0};
 //char fnum[3]={0};//no of current file max 999
 int plik;
 struct SUsr *Usr=NULL;
 struct Sfile *New,*NextF;
 char *wholetxt=NULL;
 
 Usr=WhoseID(Ramka.clientid);
 strcat(filename,Usr->Name);
 strcat(filename,"_");
 strcat(filename,Ramka.argument1);
 //powstala nazwa pliku "[nazwa_wlascicela]_[org._nazwa_pliku]"
 receive(Ramka.clientid,wholetxt);

 plik=open(filename,O_WRONLY|O_CREAT);//dodac prawa
 if(plik==-1) return;
 write(plik,wholetxt,sizeof(wholetxt));
 close(plik);
 
 New=(struct Sfile*)malloc(sizeof(struct Sfile));
 strcpy(New->Access,Ramka.argument2);
 strcpy(New->FileName,Ramka.argument1);
 New->Next=NULL;
 Usr->Fp_usr++; //powieksza l. plikow udostepnionych przez uzytk
 if(Usr->Plik==NULL) 
  {Usr->Plik=New;
   return;
  };  
 NextF=Usr->Plik;
 while(NextF->Next!=NULL) NextF=NextF->Next;
 NextF->Next=New;
};
void commit_get(void)
{
 char filename[PROTO_ARGSIZE+PROTO_ARGSIZE]={0};
 struct SUsr *UsrR=NULL,*UsrO=NULL;//User requesing & User-owner
 struct Sfile *ReqF,*NextF;
 char* wholetxt;
 int filesize,i,j,plik;

 
 //IntToStr(Ramka.clientid,sid);
 UsrR=WhoseID(Ramka.clientid);
 UsrO=WhoseName(Ramka.argument1);

 strcat(filename,Ramka.argument1);
 strcat(filename,"_");
 strcat(filename,Ramka.argument2);

 NextF=UsrO->Plik;
 while( (NextF!=NULL)||(strcmp(NextF->FileName,Ramka.argument2)==0) )
   NextF=NextF->Next;   
 if(NextF==NULL)
  {
   Ramka.command=11;
   wholetxt=(char*)malloc(sizeof(char)*PROTO_MSGBODYSIZE); 
   strcpy(wholetxt,"\n<Serwer>::Blad: Uzytkownik nie udostepnia tego zasobu.\n");
   send(Ramka.clientid,wholetxt);
   return;
  };

 if( (strcmp(NextF->Access,"")!=0)&&(strcmp(NextF->Access,UsrR->Name)!=0) )
  {
   Ramka.command=11;
   wholetxt=(char*)malloc(sizeof(char)*PROTO_MSGBODYSIZE); 
   strcpy(wholetxt,"\n<Serwer>::Blad: Nie masz uprawnien do tego pliku.\n");
   send(Ramka.clientid,wholetxt);
   return;
  };
  
 plik=open(filename,O_RDONLY);//dodac prawa
 if(plik==-1)
  {
   Ramka.command=11;
   wholetxt=(char*)malloc(sizeof(char)*PROTO_MSGBODYSIZE); 
   strcpy(wholetxt,"\n<Serwer>::Blad: Brak dostepu do pliku.\n");
   send(Ramka.clientid,wholetxt);
   return;
  };
  
 filesize=lseek(plik,0L,SEEK_END);
 wholetxt=(char*)malloc(sizeof(char)*filesize); 
 read(plik,wholetxt,filesize);
 close(plik);
 send(Ramka.clientid,wholetxt); 
};
void commit_list(void)
{
/* char* wholetxt;
 int i,j;

 UsrR=WhoseID(Ramka.clientid);

 Ramka.clientid=curr_can;
 Ramka.partnumber=0;
 Ramka.partscount=1;
 send(SERVERID);//tutaj ID te od msgget

 receive(curr_can,wholetxt);
 if(Ramka.command>10){printf("%s",Ramka.messagebody);return;}
    else printf("%s\n",wholetxt);*/
};
void commit_who(void)
{
 struct SUsr *Usr=NULL;
 char* wholetxt;
 int i,j,size;

 size=(PROTO_ARGSIZE+1)*(Serw.ID+5);
 wholetxt=(char*)malloc(sizeof(char)*size);
 for(i=0;i<size;i++) wholetxt[i]=0;
 
 sprintf(wholetxt,"<SERWER> Aktualnie zalogowanych %d.\n",Serw.ID);
 strcat(wholetxt,"Lista zalogowanych:\n");
  Usr=Serw.Next;
 while(Usr!=NULL)
 {
 strcat(wholetxt,Usr->Name);
 strcat(wholetxt,"\n");
 Usr=Usr->Next;    
 }; 
 
 send(Ramka.clientid,wholetxt);//tutaj ID te od msgget
};
void commit_stat(void)
{
 /*char* wholetxt;
 int curr,max;

 Ramka.clientid=curr_can;
 Ramka.partnumber=0;
 Ramka.partscount=1;
 send(SERVERID);//tutaj ID te od msgget

 receive(curr_can,wholetxt);

 if(Ramka.command>10){printf("%s",Ramka.messagebody);return;};

 sscanf(wholetxt,"%d %d\n",&curr,&max);
 printf("Liczba udostepnionych plikow: %d\t Max: %d\n",curr,max);
 sscanf(wholetxt,"%d %d\n",&curr,&max);
 printf("Liczba pobranych bajtow: %d\t Max: %d\n",curr,max);
*/};
void commit_kick(void)
{
 /*char* wholetxt;
 Ramka.clientid=curr_can;
 Ramka.partnumber=0;
 Ramka.partscount=1;
 send(SERVERID);//tutaj ID te od msgget
 receive(curr_can,wholetxt);
 if(Ramka.command>10){printf("%s",Ramka.messagebody);return;};
 printf("Wykopalismy go.\n");*/
};
void commit_set(void)
{
 /*char* wholetxt;

 Ramka.clientid=curr_can;
 Ramka.partnumber=0;
 Ramka.partscount=1;
 send(SERVERID);//tutaj ID te od msgget
 receive(curr_can,wholetxt);
 if(Ramka.command>10){printf("%s",Ramka.messagebody);return;};
 printf("Ustawiono.\n");*/
};
void send(int cannal,char *wholetxt)
{
 int partcount;
 int i,j;
 
 partcount=sizeof(wholetxt)/PROTO_MSGBODYSIZE;
 if((sizeof(wholetxt)%PROTO_MSGBODYSIZE)>0)
     partcount++;
 
 /*for(i=0;i<partcount;i++)
  {
   Ramka.partnumber=i;
   Ramka.partscount=partcount;
   for(j=0;(j<PROTO_MSGBODYSIZE)&&(sizeof(wholetxt)>PROTO_MSGBODYSIZE*i+j);j++)
     Ramka.messagebody[j]=wholetxt[PROTO_MSGBODYSIZE*i+j];
   msgsnd(cannal,&Ramka,PROTO_MSGSIZE,Ramka.clientid);        
  };*/
 msgsnd(cannal,&Ramka,PROTO_MSGSIZE,Ramka.clientid);        
};
void receive(int cannal,char* wholemsg)
{
 int i;

printf("SeRWID_wew: %d\n",Serw.ID);
 wholemsg=(char*)malloc(sizeof(char)*PROTO_MSGBODYSIZE*Ramka.partscount);
 for(i=0;i<Ramka.partscount;i++)
  {
   printf("Odczytano ramke %d z %d.\n",i,Ramka.partscount-1);
   if(i==Ramka.partnumber){strcat(wholemsg,Ramka.messagebody);}
    else 
     {
      strcat(wholemsg,"Blad przy odbieraniu danych.(zly nr ramki)\n");
      return;
     };
   msgrcv(srv_can,&Ramka,PROTO_MSGSIZE,0,0);//odczyt kolejnej ramki
  };
 
};

struct SUsr* WhoseID(int UsrID)
{
 struct SUsr *Head=&Serw,*Usr;
  
 Usr=Head->Next;
 while(Usr!=NULL)
 {
  if(Usr->ID==UsrID) return Usr;
  Usr=Usr->Next;   
 }; 
 return (NULL);
};
struct SUsr *WhoseName(char Name[PROTO_ARGSIZE])
{
 struct SUsr *Head=&Serw,*Usr;
  
 Usr=Head->Next;
 while(Usr!=NULL)
 {
  if(strcmp(Usr->Name,Name)==0) return Usr;
  Usr=Usr->Next;   
 }; 
 return (NULL);
};

