#include<sys/ipc.h>
#include<sys/msg.h>
#include<sys/shm.h>
#include<signal.h>


#include "protocol.h"
#include "headers.h"
#include "function.c"
#include "serverproc.c"

#define shm_key 12345


int inmsg_id;
int outmsg_id;
int shm_id;  //identyfikator pamieci wspoldzielonej
message in_message;
message out_message;
int finish=0;  //wyjscie z petli -> zakonczenie procesu
person *personTab; //wspoldzielona tabela zalogowanych 



int *X,Xid;      //maxymalna liczba uzytkownikow, X[1]  obecna liczba, Xid ident wspoldzielonej
int *Y,Yid;   //ile max plikow moze udostepnic jeden uzytkownik
int *Z,Zid;   //ile max bajtow moze pobrac jeden uzytkownik 



void end(int); //to sie wykona jak ktos zabija proces
int mkStatString(char* dest, int clientid);

//*************sprawdza czy login i kanal unikalny************************************
int check_client(int nr, char* name)
{int result=1; // wszystko OK
 int i;
 if((X[1]+1)>X[0]){result=-1;}  //nie ma miejsca
  else
 {printf("X: %d\n",X[1]); 
  for(i=0;i<X[1];i++)
   {printf("sprawdzam z : %s\n",personTab[i].nick);
    if(strcmp(personTab[i].nick,name)==0){result=0;break;}
    if(personTab[i].id==nr){result=0;break;}
   }
 } 
 return(result);
}   


//**********************tworzenia kanalu glownego i przydzaial pamieci******************
void init()
{if((inmsg_id=msgget(SERVERID,IPC_CREAT|0666))==-1)
   {perror("Blad przy tworzeniu glownego kanalu "); exit(0);}
 printf("\E[0m\n\t::SERWER::\n-kanal otwarty...\n"); 
 //tabela zalogowanych
 shm_id=shmget(shm_key, serwermaxX*sizeof(person), IPC_CREAT|0666);  
 personTab=(person*)shmat(shm_id,0,0);
 if(personTab==NULL){printf("Brak adresu tabeli zarejestrowanych!\n");exit(0);}
 //X maxX
 Xid=shmget(shm_key+1, 2*sizeof(int), IPC_CREAT|0666);  
 X=(int*)shmat(Xid,0,0);
 if(X==NULL){printf("Brak adresu X!\n");exit(0);}
 X[0]=4; X[1]=0;
 //Y
 Yid=shmget(shm_key+2, 2*sizeof(int), IPC_CREAT|0666);  
 Y=(int*)shmat(Yid,0,0);
 if(Y==NULL){printf("Brak adresu Y!\n");exit(0);}
 Y[0]=3; Y[1]=0;
 //Z
 Zid=shmget(shm_key+3, 2*sizeof(int), IPC_CREAT|0666);  
 Z=(int*)shmat(Zid,0,0);
 if(Z==NULL){printf("Brak adresu Z!\n");exit(0);}
 Z[0]=2000; Z[1]=0;
 
 mkdir(DataBaseDir,0766);
 
 signal(2,end);
 signal(SIGKILL,end);
}


//********************przyjmuje zgloszenie nowego klienta******************************
//zwraca jego numer, lub zero gdy login zajety
int pick_client()    
{if(msgrcv(inmsg_id,&in_message,sizeof(message)-sizeof(long),1,0)==-1)
  {perror("Blad przy odczycie ");exit(0);} 
 int client_id=atoi(in_message.argument2); 
 printf("ID klienta:%d\n",client_id);
 //czy login unikalny
 int res;
 if((res=check_client(client_id, in_message.argument1))==1)
      {personTab[X[1]].id=client_id;
	   strcpy(personTab[X[1]].nick, in_message.argument1);
	   personTab[X[1]].y=0;
	   personTab[X[1]].z=0;
	   X[1]++;  //zwieksza liczbe zalogowanych
	   return(client_id);}
	   
 else 
 {out_message=in_message;
 if(res==0)	   strcpy(out_message.messagebody,"!!!ten login jest juz zajety!!!");
 if(res==-1)   strcpy(out_message.messagebody,"!!!brak miejcs na serwerze!!!");
 //wysyla odmowe logowania
       outmsg_id=atoi(in_message.argument2);
       out_message.command=ERR_LOGIN;
       if(msgsnd(outmsg_id,&out_message,sizeof(message)-sizeof(long),0)==-1)
         {perror("Blad przy probie wyslania odmowy rejestracji"); exit(0);}   
	   return(0);	 
 } 
}



//*****************wyswietla zawartosc tablicy wiadomosci*****************************
void printTab(message msgTab[])
{int i;
 printf("\n##odebrano##\n");
for(i=0;i<msgTab[0].partscount;i++)
	{printf("czesc %d \n",i);
	 printf("clientid  : %d\n",msgTab[i].clientid);
	 printf("partnumber: %d\n",msgTab[i].partnumber);
	 printf("partscount: %d\n",msgTab[i].partscount);
	 printf("command   : %d\n",msgTab[i].command);
	 printf("argument1 : %s\n",msgTab[i].argument1);
	 printf("argument2 : %s\n",msgTab[i].argument2);
	 printf("msgbody   : %s\n",msgTab[i].messagebody);
	}

}

//*******************zwraca indeks osoby name w tablicy zrejestrowanych*****************
int findIndex(char *name)
{int i,hit;
i=-1;hit=0;
do{i++;
if(strcmp(personTab[i].nick,name)==0)hit=1;
  }while((hit==0)&&(i<X[1]-1));
if(hit==1)  //znalazl
	{return(i);}
else return(-1);
}	


//**********sprawdza czy dany plik jest udost przez uzytkownika******************
int findFileInPersonTab(char *filename, char *clientname)
{int i,j,k;
int OK=0;
if((i=findIndex(clientname))==-1)  //nie ma takiego uzytkownika
	{strcpy(error,"Nie mozna znalesc uzytkownika");return(-1);}
for(j=0;j<personTab[i].y;j++) //po ich plikach
	{k=j*PROTO_ARGSIZE;  //poczatek kolejnego wpisu
	if(strcmp(filename,&personTab[i].fileTab[k])==0)//jesli jest taki wpis
		OK=1;
	}
return(OK);
}
		
		
//****************dodaje nazwe pliku do tablicy uzytkownika(jesli mozliwe)**************
int addFileToPersonTab(char* filename, char* clientname)
{int index,j,pocz;
if((index=findIndex(clientname))!=-1)
	{printf("index w personTab: %d\n",index);
	if(findFileInPersonTab(filename,clientname)>0) //juz udostepniony
		{strcpy(error,"juz udostepniasz plik pod podana nazwa");
		 return(0);
		}
	if(personTab[index].y < Y[0])
		{
		printf("wartosci y=%d, Y[1]=%d\n",personTab[index].y,Y[1]);
		pocz=personTab[index].y*PROTO_ARGSIZE;//poczatek pierwszego wolnego wpisu w fileTab
		for(j=pocz;j<(pocz+PROTO_ARGSIZE);j++)//wpisuje nazwe pliku
			personTab[index].fileTab[j]=filename[j-pocz];
		personTab[index].fileTab[pocz+PROTO_ARGSIZE-1]=0; //tak dla pewnosci
		personTab[index].y++;// zwieksza liczniki udostepnionych plikow
		Y[1]++;
		return(1);
		}
	else {strcpy(error,"przekroczono maksymalna ilosc plikow na osobe");
		  return(0);}
	}
else {strcpy(error,"nie znaleziono uzytkownika");return(0);}
}	


//******************wypelnie odpowiedz na List****************************************
int prepareListStr(char* dest, char* user)
{int i,j,k;

strcpy(dest,"");
if(strcmp(user,"")==0) //listuje wszystkich
	{for(i=0;i<X[1];i++) //po uzytkownikach
		for(j=0;j<personTab[i].y;j++) //po ich plikach
			{k=j*PROTO_ARGSIZE;  //poczatek kolejnego wpisu
			strcat(dest,personTab[i].nick);
			strcat(dest," ");
			strcat(dest,&personTab[i].fileTab[k]);
			strcat(dest,"\n");
			}
	}
else{if((i=findIndex(user))==-1)  //nie ma takiego uzytkownika
		{strcpy(error,"Nie mozna znalesc uzytkownika");return(0);}
	else{for(j=0;j<personTab[i].y;j++) //po jego plikach
			{k=j*PROTO_ARGSIZE;  //poczatek kolejnego wpisu
			strcat(dest,personTab[i].nick);
			strcat(dest," ");
			strcat(dest,&personTab[i].fileTab[k]);
			strcat(dest,"\n");
			}
		}		
	}
return(1);	
}	  

//*************wykonuje przekazana wiadomosc*******************************************
void executeMsgsTab(message msgTab[], char* clientName)
{char* MsgBody;
 message msgBuff;
 char msgBody[PROTO_MSGBODYSIZE];
 char content[max_file_size];
 char path[512]={0};
 int command=msgTab[0].command, i, hit, OK;
 
 switch(command){
 case CMD_LOGOUT:delate(msgTab[0].clientid, personTab, X, &Y[1]);
 				sendMsgTab(msgTab[0].clientid, prepareMsgTable(msgTab[0],"uzytkownik odlaczony od uslugi") );
 				finish=1;
 				break;
 case CMD_SHARE:OK=1; 
 				catMsgBody(content, msgTab);
				strcpy(path,DataBaseDir);strcat(path,"/");
				strcat(path,clientName);
 				if(addFileToPersonTab(msgTab[0].argument1, clientName)==1)
				{if(writeFile(path,msgTab[0].argument2,msgTab[0].argument1,content)==1)
					{sendMsgTab(msgTab[0].clientid, prepareMsgTable(msgTab[0], "plik dodano pomyslnie") );	}
				 else {OK=0;}
				}
				else {OK=0;};
				if(OK==0){create_msg(&msgBuff,msgTab[0].clientid,0,1,ERR_SHARE,"","",error); 
						  sendMsgTab(msgTab[0].clientid,&msgBuff);}
 				//printf("SHARE:%d bajtow\n%s\n",strlen(content),content);
 				break; 
 case CMD_GET:  OK=0;
 				if(findFileInPersonTab(msgTab[0].argument2, msgTab[0].argument1))
					{
 					MsgBody=(char*)malloc(max_file_size);
 					strcpy(path,DataBaseDir);strcat(path,"/");
					strcat(path,msgTab[0].argument1);strcat(path,"/");
					strcat(path,msgTab[0].argument2);
 					if(readFile(path, MsgBody)==1)
						{OK=1;} //najpierw szuka w publicznych
					else{strcpy(path,DataBaseDir);strcat(path,"/");
						strcat(path,msgTab[0].argument1);strcat(path,"/");
						strcat(path,clientName);strcat(path,"/");
						strcat(path,msgTab[0].argument2);
						if(readFile(path, MsgBody)==1)
							{OK=1;}//jesli nie ma szuka w prywatnych
						}
					if(OK==1)
						{if((personTab[findIndex(clientName)].z+strlen(MsgBody))>Z[0]) //juz za duzo pobral	
							{OK=0; strcpy(error,"zostalo za malo bajtow do wykorzystania");}
						else {personTab[findIndex(clientName)].z+=strlen(MsgBody);	
							  Z[1]+=strlen(MsgBody);}
						}
					}	
				else{strcpy(error,"wskazany uzytkownik nie usostepnia zadanego pliku");}	
				if(OK==1)
					{sendMsgTab(msgTab[0].clientid, prepareMsgTable(msgTab[0], MsgBody) );
					}
				else {create_msg(&msgBuff,msgTab[0].clientid,0,1,ERR_GET,msgTab[0].argument1,msgTab[0].argument2,error); 
					  sendMsgTab(msgTab[0].clientid,&msgBuff);
					 }	 
 				break; 
 case CMD_LIST: MsgBody=(char*)malloc(serwermaxX * serwermaxY * PROTO_ARGSIZE);
 				if(prepareListStr(MsgBody, msgTab[0].argument1))
					{sendMsgTab(msgTab[0].clientid, prepareMsgTable(msgTab[0], MsgBody) );
					printf("LIST:\n%s\n",MsgBody);}	
				else
					{create_msg(&msgBuff,msgTab[0].clientid,0,1,ERR_SHARE,"","",error); 
					 sendMsgTab(msgTab[0].clientid,&msgBuff);}	
				free(MsgBody);	 
 				break; 
 case CMD_WHO:  MsgBody=(char*)malloc(serwermaxX*(PROTO_ARGSIZE+2)); //tyle moze max
 				printPersonTab(MsgBody,personTab,X[1]);
 				printf("\tLista:\n%s",MsgBody);
				sendMsgTab(msgTab[0].clientid, prepareMsgTable(msgTab[0], MsgBody) );
				free(MsgBody);
				break; 
				
 case CMD_STAT: MsgBody=(char*)malloc(PROTO_MSGBODYSIZE);
 				mkStatString(MsgBody, msgTab[0].clientid);
				sendMsgTab(msgTab[0].clientid, prepareMsgTable(msgTab[0], MsgBody) );
				free(MsgBody);
 				break; 
				
 case CMD_KICK: if(strcmp(clientName,"admin")==0)
 					{//wysyla jakby pseudo logout od uzytkownika ktorego usuwamy :)
 					//i=-1;hit=0;
					//do{i++;
					//	if(strcmp(personTab[i].nick,msgTab[0].argument1)==0)hit=1;
					//  }while((hit==0)&&(i<X[1]-1));
					//if(hit==1)  //znalazl
					if((i=findIndex(msgTab[0].argument1))!=-1)
 						{create_msg(&msgBuff,personTab[i].id,0,1,CMD_LOGOUT,"","","");
						if(msgsnd(inmsg_id,&msgBuff,sizeof(message)-sizeof(long),0)==-1)
							{perror("Blad przy wyslaniu komunikatu"); exit(0);}
						sendMsgTab(msgTab[0].clientid, prepareMsgTable(msgTab[0],"uzytkownik odlaczony od uslugi") );
						}
					else{
					 create_msg(&msgBuff,msgTab[0].clientid,0,1,ERR_KICK,"","","brak wskazanego uzytkownika w bazie"); 
					 sendMsgTab(msgTab[0].clientid,&msgBuff);}
					 }
				else {
				create_msg(&msgBuff,msgTab[0].clientid,0,1,ERR_KICK,"","","nie masz praw administratora!!!"); 
				sendMsgTab(msgTab[0].clientid, &msgBuff);}
				break; 
				
 case CMD_SET:  hit=1; //nie ma bledu
 				if(strcmp(clientName,"admin")==0)
 					{if(strcmp(msgTab[0].argument1,"x")==0)
 						{if((i=atoi(msgTab[0].argument2))<=serwermaxX)
						 	{X[0]=i;}else {strcpy(msgBody,"serwer nie zezwala na obsluge ponad serwermaxX osob");
											hit=0;}
						 }else
					 if(strcmp(msgTab[0].argument1,"y")==0)	 
						{if((i=atoi(msgTab[0].argument2))<=serwermaxY)
						 	{Y[0]=i;}else {strcpy(msgBody,"serwer nie zezwala na obsluge ponad serwermaxY plikow na osobe");
											hit=0;}
						 }else
					 if(strcmp(msgTab[0].argument1,"z")==0)	 
						{Z[0]=abs(atoi((msgTab[0].argument2)));
						 }else	 
						{strcpy(msgBody,"nieprawidlowy argument!!!");hit=0;}
					}
					else{strcpy(msgBody,"nie masz praw administratora!!!");hit=0;};
				if(hit==0) //wystapil blad
					{create_msg(&msgBuff,msgTab[0].clientid,0,1,ERR_SET,msgTab[0].argument1,msgTab[0].argument2,msgBody); 
					 sendMsgTab(msgTab[0].clientid, &msgBuff);}
				else
					sendMsgTab(msgTab[0].clientid, prepareMsgTable(msgTab[0],"wprowadzono zmiany") );	 
 				break; 
 }
}




//**********************obsluguje klienta w nowym wontku***************************
//client_id: numer kanalu klienta
void serve_client(int client_id, char* clientnick)
{message* messageTab;
 finish=0;  
if(fork()==0)
 {
  int   clientCanal=client_id;  //numer==kanal obslugiwanego klienta
  char  clientNick[PROTO_ARGSIZE+1];            //nazwa klienta
  printf("\nkolejka klienta: %d\n",clientCanal);
  printf("\nnazwa klienta: %s\n",clientnick);
  strcpy(clientNick,clientnick);
  out_message=in_message;
  out_message.command=1;
  if(msgsnd(clientCanal,&out_message,sizeof(message)-sizeof(long),0)==-1)
     {perror("Blad przy probie wyslania potwierdzenia rejestracji"); exit(0);}
  printf("potwierdzono rejestracje\n");
   
  while(finish==0)
   {
	messageTab=reciveMsgsToTab(inmsg_id, clientCanal);
    //printTab(messageTab);
	executeMsgsTab(messageTab, clientNick);
	printf("obsluzono\n");
	free(messageTab);
	}
  exit(0);
 }

} 

//***********generuje odp na stat dla admina******************************************
int mkStatStringAdmin(char* dest)
{int i=-1;
 char buf[15]={0};
printf("ADMIN\n");
sprintf(buf,"%d",X[1]);strcpy(dest,buf);strcat(dest," ");
sprintf(buf,"%d",X[0]);strcat(dest,buf);strcat(dest,"\n"); 
sprintf(buf,"%d",Y[1]);strcat(dest,buf);strcat(dest," ");
sprintf(buf,"%d",Y[0]);strcat(dest,buf);strcat(dest,"\n");
sprintf(buf,"%d",Z[1]);strcat(dest,buf);strcat(dest," ");
sprintf(buf,"%d",Z[0]);strcat(dest,buf);strcat(dest,"\n");
//wypisuja wszystkie dane z tablicy
do{ i++;
strcat(dest,personTab[i].nick);strcat(dest," ");
sprintf(buf,"%d",personTab[i].y);strcat(dest,buf);strcat(dest," ");
sprintf(buf,"%d",personTab[i].z);strcat(dest,buf);strcat(dest,"\n");
}while(i<X[1]-1);
}

//***************generuje odp na stat **********************************************************************
int mkStatString(char* dest, int clientid)
{int hit=0,i=-1;
 char buf[15]={0};
//szuka osoby w tablicy
do{ i++;
	if(personTab[i].id==clientid)hit=1;
}while((hit==0)&&(i<X[1]-1));
if(hit==0){strcpy(dest,"blad!!! niespojnosc w bazie danych...\n");return(0);}

if(strcmp(personTab[i].nick,"admin")==0){mkStatStringAdmin(dest);}
else
{	sprintf(buf,"%d",personTab[i].y);strcpy(dest,buf);strcat(dest," ");
	sprintf(buf,"%d",*Y);             strcat(dest,buf);strcat(dest,"\n");
	sprintf(buf,"%d",personTab[i].z);strcat(dest,buf);strcat(dest," ");
	sprintf(buf,"%d",*Z);             strcat(dest,buf);strcat(dest,"\n");
}
}


//*****************sprzata po sobie****************************************************
void end(int signal)
{
 msgctl(inmsg_id,IPC_RMID,NULL);
 shmctl(shm_id,IPC_RMID,NULL);
 shmctl(   Xid,IPC_RMID,NULL);
 shmctl(   Yid,IPC_RMID,NULL);
 shmctl(   Zid,IPC_RMID,NULL);
 printf("Zakonczono ::SERWER::\n");
 if(fork()==0)
	{execlp("rm","rm",DataBaseDir,"-r",NULL);};	
 exit(signal);
};



//**************************************************************************************
//*                        SERVER                                                      *
//**************************************************************************************
int main(int argc,char *argv[])
{
int nr;
init();
do
{
 nr=pick_client();
 if(nr!=0){serve_client(nr, in_message.argument1);}
}while(true); 
end(0);
};

