/*
  Rozszerzony protokol sieci wymiany plikow wg. protokolu grupy I4, z srody 8:00
  Jacek Pospychaa (66301)
 */

#ifndef IPC1500PROTOCOL_H
#define IPC1500PROTOCOL_H

/* server message queue KEY. podajemy jako argument msgget, by uzyskac msgid:

   msgid = msgget(SERVERID, 0644);
 */

#define SERVERID 1500


/* message structure:

  PROTO_MSGSIZE - calkowity rozmiar struktury
  PROTO_ARGSIZE - rozmiar argumentu 1 i 2
  PROTO_MSGBODYSIZE - rozmiar messagebody
*/

#define PROTO_MSGSIZE 512

#define PROTO_ARGSIZE 16
#define PROTO_MSGBODYSIZE (PROTO_MSGSIZE - (sizeof(long) + 3*sizeof(int) + 2*PROTO_ARGSIZE))

struct message {
  long clientid;
  unsigned int partnumber;
  unsigned int partscount;
  int command;
  char argument1[PROTO_ARGSIZE];
  char argument2[PROTO_ARGSIZE];
  char messagebody[PROTO_MSGBODYSIZE];
};


/* commands and errors */

#define CMD_LOGIN      1
#define CMD_LOGOUT     2
#define CMD_SHARE      3
#define CMD_GET        4
#define CMD_LIST       5
#define CMD_WHO        6
#define CMD_STAT       7
#define CMD_KICK       8
#define CMD_SET        9
#define ECMD_ALLOW     101
#define ECMD_SHUTDOWN  102
#define ECMD_KICKALL   103
#define ECMD_UNSHARE   104

#define ERR_LOGIN         11
#define ERR_LOGOUT        12
#define ERR_SHARE         13
#define ERR_GET           14
#define ERR_LIST          15
#define ERR_WHO           16
#define ERR_STAT          17
#define ERR_KICK          18
#define ERR_SET           19
#define ERRECMD_ALLOW     111
#define ERRECMD_SHUTDOWN  112
#define ERRECMD_KICKALL   113
#define ERRECMD_UNSHARE   114

#endif
