/****
   LTPS - Linux Text Presentation System
                                       ****/

#ifndef TMP_STYLE
#define TMP_STYLE

using namespace std;

typedef int Color;
typedef enum horizontal_alignment_type {ha_left, ha_center, ha_right, ha_justify} Alignment;
typedef enum vertical_alignment_type {va_top, va_center, va_bottom} Vertical_alignment;

class Style {
 private:
 Color color;
 Color background_color;
 Alignment align;
 Vertical_alignment vertical_align;

 int margin_left;
 int margin_right;
 int margin_top;
 int margin_bottom;

 public:
 // constructors
 Style();
 Style(Color color, Color background_color, Alignment align, Vertical_alignment vertical_align, 
       int margin_left, int margin_right, int margin_top, int margin_bottom);
 
 // getters
 int getmarginleft() {return margin_left;}
 int getmarginright() {return margin_right;}
 int getmarginbottom() {return margin_bottom;}
 int getmargintop() {return margin_top;}
 int getcolor() {return color;}
 int getbackgroundcolor() {return background_color;}
 Alignment getalign() {return align;}
 Vertical_alignment getverticalalign() {return vertical_align;}

 // setters
 int setmargin(int m) {return margin_left=margin_right=margin_top=margin_bottom=m; }
 int setmarginleft(int m) {return margin_left=m;}
 int setmarginright(int m) {return margin_right=m;}
 int setmarginbottom(int m) {return margin_bottom=m;}
 int setmargintop(int m) {return margin_top=m;}
 int setcolor(Color c) {return color=c;}
 int setbackgroundcolor(Color c) {return background_color=c;}
 Alignment setalign(Alignment a) {return align=a;}
 Vertical_alignment setverticalalign(Vertical_alignment v) {return vertical_align=v;}
};

#endif
